% [F matches] = BEEM(image1,image2,distanceRatio)
%
% This function gets:
% image1 - first image filename
% image2 - second image filename
% distanceRatio - the distance ratio of the closest to the second-closest
% it calculates F and supportted inliers and saves those to files
%
%  [F matches] = BEEM('un_north_A.bmp','un_south_A.bmp',0.8)


function [F matches] = BEEM(image1,image2,distanceRatio)

img1 = imread(image1);
imwrite(img1,'img1.pgm','pgm');
img2 = imread(image2);
imwrite(img2,'img2.pgm','pgm');
system(sprintf('BEEM 1  img1.pgm img2.pgm  %2.1f',distanceRatio));
F = textread('F.txt');
F(:,4) = [];
matches = textread('matches.txt');
matches(:,5) = [];

% Create a new image showing the two images side by side.
im3 = appendimages(img1,img2);
% Show a figure with lines joining the accepted matches.
figure('Position', [100 100 size(im3,2) size(im3,1)]);
imshow(im3,[]);
hold on;
cols1 = size(img1,2);
for i = 1: size(matches,1)
    line([matches(i,1) matches(i,3)+cols1], [matches(i,2) matches(i,4)], 'Color','c');
end
hold off;