#include "StdAfx.h"
#include "MyMath.h"
//#include "LSH.h"
#include <ctime>
#include "Beem.h"
#include "SiftUtil.h"
#include "LSH.h"
//autohr : itaym

 MyMath myMathHelper;

void myMethod(int K , int L , int K_neigh , MyMath::MyData& desc1 , MyMath::MyData& cor1 , MyMath::MyData& desc2 , MyMath::MyData& cor2 , double argDrValue);
void LSH_matching(char const * argImg1Name,char const * argImg2Name,int K,int L,int k_neigh,double argDrValue, int argRansacTrValue);

int main(int argc, char* argv[])
{
	/*
		possible arguments:
		1. mode - 1 for before and 2 for after matchig
		2. if mode=1 img1 file name, if mode=0 ransac_tr value
		3. if mode=1 img2 file name
		4. if mode=1 dr value - distance ratio between the closest and the second closest matches.   --> if -1 than set to default= 0.8 (to handle recieving 4 args but not wanting to set dr value)
		5. if mode=1 ransac_tr value
	*/
	char const * argImg1Name = "img1.pgm";
	char const * argImg2Name = "img2.pgm";
	double argDrValue = 0.8;
	int argRansacTrValue = 5;

	int K, L, k_neigh, mode;
	K = 12;//38; //20
	L = 15; //18
	k_neigh = 2;
	mode = 1;

	if (argc >= 2){
		mode = atoi(argv[1]);
	}
	if (mode == 1){
		if (argc == 8){
			L = atoi(argv[7]);
		}
		if (argc >= 7){
			K = atoi(argv[6]);
		}
		if (argc >= 6){
			argRansacTrValue = atoi(argv[5]);
		}
		if (argc >= 5){
			argDrValue = atof(argv[4]);
		}
		if (argc >= 4){
			argImg2Name  = argv[3];
		}
		if (argc >= 3){
			argImg1Name  = argv[2];
		}
		LSH_matching(argImg1Name,argImg2Name,K,L,k_neigh,argDrValue,argRansacTrValue);
	} else {
		if (argc == 6){
			L = atoi(argv[5]);
		}
		if (argc == 5){
			K = atoi(argv[4]);
		}
		if (argc >= 4){
			argRansacTrValue = atoi(argv[3]);
		}
		if (argc >= 3){
			argDrValue = atof(argv[2]);
		}		
	}
    double percentOfOutliersParam = 1;

	//Run Beem:
	//srand(931316785);
	srand((unsigned)time(0)); 
	Beem *beem = new Beem(argRansacTrValue , percentOfOutliersParam);
	
	(*beem).executeBeem();

	cout << "F Matrix: " << endl;
	(*beem).myMathHelper.printMatrix((*beem).F);
	
	// writing the F matrix to a text file
 	ofstream myfile;
	myfile.open ("F.txt");

	for (int i=0 ; i<(*beem).F.numOfRows ; i++)
	{
		for (int j=0 ; j<(*beem).F.numOfCols ; j++)
		{
			myfile << (*beem).F.getCell(i,j) << " ";
		}
		myfile << endl;
	}
	myfile.close();
	bgLog1("End of F");

return 0;
}

Beem::Beem(int ransac_tr_param , double percentOfOutliersParam)
{
	////cout << "start of constructor"<<endl;
	/*
	ifstream file("randValues");
	//ifstream file("randValues2");
	//ifstream file("randValues3");
	int seedNumber;
	file >> seedNumber;
	file >> randValuesSize;
	randValues = new double[randValuesSize];
	for (int i=0 ; i<randValuesSize ; i++)
	{
		file >> randValues[i];
		cout << i << endl;
	}
	randValuesIterator = 0; //initializing the iterator
	*/
	////cout << "start of variables init method" << endl;

	init(ransac_tr_param , percentOfOutliersParam);
	
	////cout << "end of variables init method" << endl;

	////cout << "end of constructor"<<endl;
}

Beem::~Beem(void)
{
}

// using matlab rand seed : 931316785

void Beem::executeBeem()
{
	cout << "starting Beem algorithm" << endl;
	//	priorEstimation();   -- done in the constructor init()
	
	
	while (iter<N_BEEM)
	{
		//cout << "WHILE N_BEEM with iter: " << iter << endl;
		gotPin=0;
		Pin=calcPin(cr_outCDF_Output.outCdf,max(iter,1),maxInGr_N,cr_outCDF_Output.maxNoGrOut,updatePin);
		
		if (Pin==1)
		{
			cout << "exit now to final local exploration" <<endl;	
			break;
		}
		iter++;
		iterDD++;
		if (( (NgrSam==7) && (noOfsol==1)) || (NgrSam!=7))
		{
			if ((myRandomGenerator() >= Pin) || (floor((double)maxInGr_N/2) <NgrSam))
			{
				//cout << "start global exploration" <<endl;
				globalExploration();
				//cout << "finished global exploration" <<endl;
			} else 
			{
				//cout << "start local exploration" <<endl;
				localExploration();	
				//cout << "finished local exploration" << endl;
			}
		} else
		{
			curSol7=curSol7+1;
		}
	}
	if (iter>N_BEEM){
		F=myMathHelper.zeros(3,3);
		cout << "NO F found " << iter << " " << N_BEEM << endl;
		return;
	}
	finalLocalExploration();
	
	MyMath::MyData myMatches = myMathHelper.zeros(maxInGr_N,4);
	for (int i =0 ; i<maxInGr_N ; i++){
		//cout << maxInGr.getCell(i,0) << endl;
		for (int j=0 ; j<4 ; j++){
			myMatches.getCell(i,j) = match.getCell((int)maxInGr.getCell(i,0),j);
			//cout << match.getCell((int)maxInGr.getCell(i,0),j) << " " ;
		}
		//cout << endl;
	}
	myMathHelper.printMatToFileStandard(myMatches,"matches.txt");
	
	InIndex= maxInGr;
	//cout << "iterDD = " << iterDD << endl;
	cout << "total number of iterations = " << iterDD << " inlier matches " << maxInGr_N << endl;
	
	ifstream file("distanceRatio");
	int LSH_numOfRows = 0;
	file >> LSH_numOfRows;
	if(LSH_numOfRows<8)
	{
		F=myMathHelper.zeros(3,3);
		cout << "LSH Failed - not enought inliers" << endl;
	} else
	{
		if(maxInGr_N>=8)
		{
			//F=epoint(match(InIndex,:));
			F=epoint(myMathHelper.getRows(match,InIndex),1);
		} else
		{
			F=myMathHelper.zeros(3,3);
			cout << "BEEM Failed - not enought inliers" << endl;
		}
	}	
	
	////cout << "clean counter" << cleanCounter <<endl;
	//
	//if(chkStatis),
	//	RANSACres(1,5)=iter;
	//	tmp=sum(ismember(allIn,maxInGr));
	//	RANSACres(1,6)=tmp;
	//	tmp=sum(ismember(outDegIn,maxInGr));
	//	RANSACres(1,7)=tmp;
	//end
	//
} // end of method


void Beem::globalExplorationDecisionsMaker()
{
	if ((InGr_N>maxGrPhase1)&&(InGr_N>NgrSam)&&(gr.numOfRows==NgrSam))
	{
		//cout << "*" ;
		cout << "improvment by global exploration new size of group " << InGr_N << endl;
		if ( (InGr_N>maxGrPhase1)&&(Ngold<=0)/*no exploitation, yes global exploration*/&&(gr.numOfRows==NgrSam) )
		{
			maxGrPhase1=InGr_N;
			if (InGr_N>=NgrSam*2 )  // minimum required improvment neccesary
			{
				saveResultsForExploitation();
				firstTime=1;
			}
		}
		// do phase 2
		phase2Exploitation();
		// print if newMax
		printExploitationImprovment();
		firstTime=0;
	}
}
void Beem::localExplorationDecisionsMaker()
{
	if ((InGr_N>maxBigGr_N)&&(InGr_N>NgrSam)&&(gr.numOfRows>NgrSam)&&(Pin<1))
	{
		//cout << "*" ;
		cout << "improvment by local exploration new size of group " << InGr_N << endl;
		if ( (InGr_N>maxBigGr_N) && (gr.numOfRows>NgrSam) )  // not global exploration - explotation or local exploration or final local exploration
		{
			maxBigGr_N=InGr_N;
			saveResultsForExploitation();
			firstTime=1;
		}
		// do phase 2
		phase2Exploitation();
		// print if newMax
		printExploitationImprovment();
		firstTime=0;
	}
}
void Beem::exploitationDecisionsMaker()
{
	if (((InGr_N>maxBigGr_N)&&(InGr_N>NgrSam)&&(gr.numOfRows>NgrSam)&&(Pin<1)) //local exploration + exploitation
		|| 
		((InGr_N>=maxPin_N)&&(InGr_N>NgrSam)&&(gr.numOfRows>NgrSam)&&(Pin==1))) //final local exploration + exploitation
	{
		//cout << "*" ;
		cout << "improvment by exploitation new size of group " << InGr_N << endl;
		if ( (InGr_N>maxBigGr_N) && (gr.numOfRows>NgrSam) )  // not global exploration - explotation or local exploration or final local exploration
		{
			maxBigGr_N=InGr_N;
			saveResultsForExploitation();
			firstTime=1;
		}
		if ( (InGr_N>maxPin_N) && (gr.numOfRows>NgrSam) && (Pin==1) ) //final local exploration
		{
			maxPin_N=InGr_N;
			saveResultsForExploitation();
			firstTime=1;
		}
		// do phase 2
		phase2Exploitation();
		// print if newMax
		printExploitationImprovment();
		firstTime=0;
	}
}
void Beem::finalLocalExplorationDecisionsMaker()
{
	if ((InGr_N>=maxPin_N)&&(InGr_N>NgrSam)&&(gr.numOfRows>NgrSam)&&(Pin==1)) //final local exploration + exploitation
	{
		//cout << "*" ;
		cout << "improvment by final local exploration from " << maxPin_N << " to " <<  InGr_N << " iter " << i_order<<endl;
		if ( (InGr_N>maxPin_N) && (gr.numOfRows>NgrSam) && (Pin==1) ) //final local exploration
		{
			maxPin_N=InGr_N;
			saveResultsForExploitation();
			firstTime=1;
		}
		// do phase 2
		phase2Exploitation();
		// print if newMax
		printExploitationImprovment();
		firstTime=0;
	}
}

void Beem::saveResultsForExploitation()
{
	Ngold=MaxGoldIter;  // start exploitatin
	maxInGrCur_N=InGr_N;
	//maxInGrCur=InGr;   // the inliers group for the best model
	maxInGrCur.copyMyDataNoAlloc(InGr);
}

void Beem::phase2Exploitation()
{
	////%% Phase 2 - exploitation
	cont=1;
	prevInGr_N=InGr_N;
	while(cont)
	{
		if (LO)  // build F from all possible inliers and not just raffel
		{
			estimateFAllInliers();
		}
		buildInliersGroup();
		
		if (prevInGr_N<InGr_N)
		{
			prevInGr_N=InGr_N;
		} else
		{
			cont=0;
		}
		if (InGr_N>maxInGrCur_N)  // connected to exploitation
		{
			maxInGrCur_N=InGr_N;
			//maxInGrCur=InGr;
			maxInGrCur.copyMyDataNoAlloc(InGr);
		}
		if (InGr_N>maxInGr_N)
		{
			newMax=1;
			maxInGr_N=InGr_N;
			//maxInGr=InGr;
			maxInGr.copyMyDataNoAlloc(InGr);
			firstTime=0;
			if (Pin==1)  // final local exploration
			{
				//[vec_order, N_order, i_order_update]=update_order(maxInGr, probLiran);
				//updateOrderOutput = update_order(maxInGr, probLiran);
				updateOrderOutput = update_order();
				vec_order = myMathHelper.copyMatrix(updateOrderOutput.vec_order);
				N_order = updateOrderOutput.N_order;
				i_order_update = updateOrderOutput.i_order;
				i_order_update++;
				N_BEEM=iter+N_order;
			}
		}
	} // end of while(cont)
}

void Beem::printExploitationImprovment()
{
	if (newMax)
	{
		newMax=0;
		//int Pin_print=calcPin(cr_outCDF_Output.outCdf,iter,maxInGr_N,cr_outCDF_Output.maxNoGrOut,updatePin);
		if(!updatePin)
		{
			int tmp=min((int)floor(log(1-0.99)/log(1-pow((double)(maxInGr_N/N),NgrSam)) + 0.5),N_BEEM);
			if (tmp>0)
			{
				N_BEEM=tmp;
			}
		}
		//if (firstTime), fprintf('*iter %d/%d,  gr %d/%d=%0.2g \n',iter,N_BEEM,maxInGr_N,N,maxInGr_N/N);
		if (firstTime) // line 601
		{
			cout << "first, iterDD: " << iterDD << endl;
			cout << "*iter " << iter << "/"	<< N_BEEM << ", gr " << maxInGr_N << "/" << N << "=" << (double)maxInGr_N/N << endl;
		} else
		{
			//else fprintf(' iter %d/%d,  gr %d/%d=%0.2g \n',iter,N_BEEM,maxInGr_N,N,maxInGr_N/N);end
			////cout << "second, iterDD: " << iterDD << endl;
			////cout << " iter " << iter << "/" << N_BEEM << ", gr " << maxInGr_N << "/" << N << "=" << (double)maxInGr_N/N << endl;
			cout << "total number of iterations: " << iterDD << endl;
			cout << "global Num Of Iterations: " << iter << "/" << N_BEEM << ", size of new group " << maxInGr_N << "/" << N << "=" << (double)maxInGr_N/N << endl;
		}
		if (maxInGr_N>=Ngoal)
		{
			cout << iterDD << endl;
			return;
		}
	}
}
// building the group of inliers that agree with F matrix
void Beem::buildInliersGroup()
{
	InGr_N=0;
	//InGr=myMathHelper.zeros(1,N);
	InGr.setNumOfRowsAndCols(N,1);
	
	for (int i=0 ; i<N ; i++)
	{		
		myMathHelper.mulFWith3elements2Results(v1, F , match.getCell(i,0) , match.getCell(i,1) , 1 , false);
		myMathHelper.mulFWith3elements2Results(v2, F , match.getCell(i,2) , match.getCell(i,3) , 1 , true);
		if ((SQR(match.getCell(i,2)*v1[0]+match.getCell(i,3)*v1[1]+v1[2])) / (SQR(v1[0]) + SQR(v1[1]) + SQR(v2[0]) + SQR(v2[1])) < ransac_tr)
		{
		  if (constraintAll3SIFTpoints){
		    myMathHelper.mulFWith3elements2Results(v1, F , match_g.getCell(i,0) , match_g.getCell(i,1) , 1 , false);
		    myMathHelper.mulFWith3elements2Results(v2, F , match_g.getCell(i,2) , match_g.getCell(i,3), 1 , true);
		    myMathHelper.mulFWith3elements2Results(v1_1 , F , match_g1.getCell(i,0) , match_g1.getCell(i,1) , 1 , false);
		    myMathHelper.mulFWith3elements2Results(v2_1 , F , match_g1.getCell(i,2) , match_g1.getCell(i,3) , 1 , true);
		    myMathHelper.mulFWith3elements2Results(v1_2 , F , match_g2.getCell(i,0) , match_g2.getCell(i,1) , 1 , false);
		    myMathHelper.mulFWith3elements2Results(v2_2 , F , match_g2.getCell(i,2) , match_g2.getCell(i,3) , 1 , true);
		    
		    
		    if( ((SQR(match_g.getCell(i,2)*v1[0]+match_g.getCell(i,3)*v1[1]+v1[2])/(SQR(v1[0])+SQR(v1[1])+SQR(v2[0])+SQR(v2[1])))
			 <ransac_tr*multSIFTd*rr1.getCell(i,1)*rr2.getCell(i,1))
			&& 
			((SQR(match_g1.getCell(i,2)*v1_1[0]+match_g1.getCell(i,3)*v1_1[1]+v1_1[2])/(SQR(v1_1[0])+SQR(v1_1[1])+SQR(v2_1[0])+SQR(v2_1[1])))
			 <ransac_tr*multSIFTd*rr1.getCell(i,1)*rr2.getCell(i,1)) 
			&& 
			((SQR(match_g2.getCell(i,2)*v1_2[0]+match_g2.getCell(i,3)*v1_2[1]+v1_2[2])/(SQR(v1_2[0])+SQR(v1_2[1])+SQR(v2_2[0])+SQR(v2_2[1])))
			 <ransac_tr*multSIFTd*rr1.getCell(i,1)*rr2.getCell(i,1)))
		      {					
			InGr.getCell(InGr_N,0)=i;
			InGr_N = InGr_N + 1;
		      }
		  } else
		    {
		      InGr.getCell(InGr_N,0)=i;
		      InGr_N=InGr_N+1;
		    }
		}
	}

	//InGr=myMathHelper.getColumns(InGr, 0, InGr_N-1);
	//
	int index=0;
	for (int i=0 ; i<N ; i++)
	{
		if (InGr.getCell(i,0)>0)
		{
			InGr.getCell(index++,0) = InGr.getCell(i,0);
		}
	}
	InGr.setNumOfRowsAndCols(InGr_N,1);
	//

	//    %%%%%%%%%%%%%%%%%%%%%%% Clean repeated corners    
	if (InGr_N>1)
	{
		cleanCounter++;
		repeatCount=0;
		//chD=[match(InGr,1:4) InGr'];
		MyMath::MyData matchInGr14 = myMathHelper.getMatrix(match,InGr,0,3);
		//chD=myMathHelper.concatMatricesMoreColumns(matchInGr14,myMathHelper.transposeMatrix(InGr));
		chD=myMathHelper.concatMatricesMoreColumns(matchInGr14,InGr);
		chD=myMathHelper.sortRows(chD,1); // line 443
		for (int i=0 ; i<(InGr_N-1) ; i++)
		{
			if ( (chD.getCell(i,0) == chD.getCell(i+1,0)) && (chD.getCell(i,1) == chD.getCell(i+1,1)) )
			{
				repeatCount=repeatCount+1;
				chD.getCell(i,4)=0;
			}
		}
		chD=myMathHelper.sortRows(chD,3);
		for (int i=0 ; i<(InGr_N-1) ; i++)
		{
			if ( (chD.getCell(i,2)==chD.getCell(i+1,2)) && (chD.getCell(i,3)==chD.getCell(i+1,3)) )
			{
				if (!((chD.getCell(i,0) == chD.getCell(i+1,0)) && (chD.getCell(i,1) == chD.getCell(i+1,1))))
				{
					repeatCount=repeatCount+1;
					chD.getCell(i,4)=0;
				}
			}
		}
		//InGr=chD(find(chD(:,5)), 5);
		//InGr = myMathHelper.getRows(myMathHelper.getColumn(chD,4) , myMathHelper.findIndexesInMatrix(myMathHelper.getColumn(chD,4)));
		//
		int index=0;
		for (int i=0 ; i<InGr_N ; i++)
		{
			if (chD.getCell(i,4) > 0)
			{
				InGr.getCell(index++,0) = chD.getCell(i,4);
			}
		}
		InGr_N -= repeatCount;
		InGr.setNumOfRowsAndCols(InGr_N,1);
		//
	}
}

void Beem::estimateF()
{
	if (gr.numOfRows>=8) // we have 8 or more point matches and we can use the 8 point algorithm
	{
		//MyMath::MyData ePointInput = myMathHelper.getRows(match,gr);
		ePointInput.setNumOfRowsAndCols(gr.numOfRows,4);
		for (int i=0; i<gr.numOfRows ; i++)
		{
			for (int j=0; j<4 ; j++)
			{
				ePointInput.getCell(i,j) = match.getCell((int)gr.getCell(i,0),j);
			}
		}
		if (gotPin)  /// local exploration
		{	
			int index = ePointInput.numOfRows;
			ePointInput.setNumOfRowsAndCols(ePointInput.numOfRows+3,4);
			int cellIndex = (int)gr.getCell(gr_sz-1,0);
			for (int j=0 ; j<4 ; j++)
			{
				ePointInput.getCell(index,j) = match_g.getCell(cellIndex,j);
				ePointInput.getCell(index+1,j) = match_g1.getCell(cellIndex,j);
				ePointInput.getCell(index+2,j) = match_g2.getCell(cellIndex,j);
			}
		}
		//F=epoint(ePointInput , 1);
		F.assign(epoint(ePointInput , 1));
	} else
	{
		if ( (NgrSam==7) && (gr.numOfRows==7) )
		{
			 /// [F,noOfsol]=spoint([match(gr,:)],curSol7,0);  
			noOfsol = spoint(myMathHelper.getMatrix(match,gr,0,match.numOfCols-1),curSol7,0);  
			if (noOfsol==curSol7)
			{
				noOfsol=1;
				curSol7=1;
			}
		} else
		{
			//F=epoint([match(gr,:); match_g(gr,:); match_g1(gr,:); match_g2(gr,:)],1);
			ePointInput.setNumOfRowsAndCols(gr.numOfRows*4,4);
			int cellIndex = 0;
			for (int i=0; i<gr.numOfRows ; i++)
			{
				cellIndex = (int)gr.getCell(i,0);
				for (int j=0; j<4 ; j++)
				{
					ePointInput.getCell(i,j) = match.getCell(cellIndex,j);
					ePointInput.getCell(i+gr.numOfRows,j) = match_g.getCell(cellIndex,j);
					ePointInput.getCell(i+2*gr.numOfRows,j) = match_g1.getCell(cellIndex,j);
					ePointInput.getCell(i+3*gr.numOfRows,j) = match_g2.getCell(cellIndex,j);
				}
			}
			//F = epoint(ePointInput,1);
			F.assign(epoint(ePointInput,1));
			/*cout << "F rows size " << F.numOfRows << " and cols size " << F.numOfCols << endl;
			cout << " F Vals: " << F.matrix[0][0] << " " << F.matrix[0][1] << " " << F.matrix[0][2] << endl;
			exit(1);*/
		}
	}
}

// build F from all possible inliers and not just raffel
void Beem::estimateFAllInliers()
{
	if (InGr.numOfRows>=8)
	{
		//F=epoint([match(InGr,:)]);
		//F = epoint(myMathHelper.getRows(match,InGr),1);
		ePointInput.setNumOfRowsAndCols(InGr.numOfRows,4);
		for (int i=0; i<InGr.numOfRows ; i++)
		{
			for (int j=0; j<4 ; j++)
			{
				ePointInput.getCell(i,j) = match.getCell((int)InGr.getCell(i,0),j);
			}
		}
		//F = epoint(ePointInput , 1);
		F.assign(epoint(ePointInput , 1));
	} else
	{
		if (NgrSam<7)
		{
			//
			ePointInput.setNumOfRowsAndCols(InGr.numOfRows*4,4);
			int cellIndex = 0;
			for (int i=0; i<InGr.numOfRows ; i++)
			{
				cellIndex = (int)InGr.getCell(i,0);
				for (int j=0; j<4 ; j++)
				{
					ePointInput.getCell(i,j) = match.getCell(cellIndex,j);
					ePointInput.getCell(i+InGr.numOfRows,j) = match_g.getCell(cellIndex,j);
					ePointInput.getCell(i+2*InGr.numOfRows,j) = match_g1.getCell(cellIndex,j);
					ePointInput.getCell(i+3*InGr.numOfRows,j) = match_g2.getCell(cellIndex,j);
				}
			}
			//
			//F=epoint([match(InGr,:); match_g(InGr,:); match_g1(InGr,:); match_g2(InGr,:)]);
			//F = epoint(ePointInput,1);
			F.assign(epoint(ePointInput,1));
		}
	}
}
void Beem::init(int ransac_tr_param , double percentOfOutliersParam)
{
	F = myMathHelper.zeros(3,3);
	cleanCounter=0;
	//input params:
	////cout << "start reading input, cells  "<< MyMath::MyData::cells << " nmats " << MyMath::MyData::nmats<<endl;
	p1_m = myMathHelper.createMat("p1_m"); //load p1_m;
	p2_m = myMathHelper.createMat("p2_m"); //load p2_m;
	rr1 = myMathHelper.createMat("rr1"); //load rr1;
	rr2 = myMathHelper.createMat("rr2"); //load rr2;
	distanceRatio = myMathHelper.createMat("distanceRatio"); //load distanceRatio;
	////cout << "finish reading input, cells  "<< MyMath::MyData::cells << " nmats " << MyMath::MyData::nmats<<endl;

	Ngoal=99999;
	N_BEEM=500;
	updatePin=1;
	NgrSam=2;
	constraintAll3SIFTpoints=1;
	MaxGoldIter=10;
	LO=1;
	chkStatis=0;
	outPdf = myMathHelper.createMat("outPdf"); //load outPDF;
	gotPin=0;
	multSIFTd=1;
	probLiran = Beem::NinEstCDF(distanceRatio);
	probLiran.assign(myMathHelper.divideInScalar(probLiran,myMathHelper.findMaxInMatrix(probLiran)));
	//ransac_tr=5;
	ransac_tr = ransac_tr_param;
	generateLength=7;
	
	//cout << "starting Beem algorithm" << endl;
	
	match = myMathHelper.concatMatricesMoreColumns(p1_m, p2_m);
	N= match.numOfRows;
	////cout << "aa" <<endl;
	//cr_outCDF_Output = cr_outCDF(N,outPdf);
	//MyMath::MyData outPdfCopy;
	//outPdfCopy = outPdf; // TODO: replace by using a copy constructor
	cr_outCDF(N,outPdf,cr_outCDF_Output);
	
	for (int i=0;i<outPdf.allocatedNumOfRows;i++)
	{
		delete outPdf.matrix[i];
	}

	delete outPdf.matrix;
	//cr_outCDF(N,outPdfCopy,cr_outCDF_Output);
	////cout << "bb" <<endl;

	match_g = myMathHelper.zeros(N,4);
	match_g1 = myMathHelper.zeros(N,4);
	match_g2 = myMathHelper.zeros(N,4);
	
	for (int i=0 ; i<N ; i++)
	{
		double x=generateLength*cos(rr1.getCell(i,0))*rr1.getCell(i,1)+p1_m.getCell(i,0);
		double y=-generateLength*sin(rr1.getCell(i,0))*rr1.getCell(i,1)+p1_m.getCell(i,1);
		match_g.getCell(i,0)=x;
		match_g.getCell(i,1)=y;
		x=generateLength*cos(rr2.getCell(i,0))*rr2.getCell(i,1)+p2_m.getCell(i,0);
		y=-generateLength*sin(rr2.getCell(i,0))*rr2.getCell(i,1)+p2_m.getCell(i,1);
		match_g.getCell(i,2)=x;
		match_g.getCell(i,3)=y;

		double ang=2*PI/3;
		x=generateLength*cos(rr1.getCell(i,0) + ang)*rr1.getCell(i,1)+p1_m.getCell(i,0);
		y=-generateLength*sin(rr1.getCell(i,0) + ang)*rr1.getCell(i,1)+p1_m.getCell(i,1);
		match_g1.getCell(i,0)=x;
		match_g1.getCell(i,1)=y;
		x=generateLength*cos(rr2.getCell(i,0) + ang)*rr2.getCell(i,1)+p2_m.getCell(i,0);
		y=-generateLength*sin(rr2.getCell(i,0) + ang)*rr2.getCell(i,1)+p2_m.getCell(i,1);
		match_g1.getCell(i,2)=x;
		match_g1.getCell(i,3)=y;

		ang=2*PI*2/3;
		x=generateLength*cos(rr1.getCell(i,0) + ang)*rr1.getCell(i,1)+p1_m.getCell(i,0);
		y=-generateLength*sin(rr1.getCell(i,0) + ang)*rr1.getCell(i,1)+p1_m.getCell(i,1);
		match_g2.getCell(i,0)=x;
		match_g2.getCell(i,1)=y;
		x=generateLength*cos(rr2.getCell(i,0) + ang)*rr2.getCell(i,1)+p2_m.getCell(i,0);
		y=-generateLength*sin(rr2.getCell(i,0) + ang)*rr2.getCell(i,1)+p2_m.getCell(i,1);
		match_g2.getCell(i,2)=x;
		match_g2.getCell(i,3)=y;
	}

	//if (chkStatis)
	//	load allIn;
	//	load degIn;
	//	outDegIn=setdiff(allIn, degIn);
	//end

	/////RANSAC 3

	iterDD=0;
	iter=0;
	//int iterGlobal=0;
	maxInGr_N=0;

	maxInGrCur_N=0;

	firstTime=0;
	Ngold=0;
	maxGrPhase1=0;
	
	maxBigGr_N=0;
	maxPin_N=0;
	newMax=0;
	Pin=0;

	curSol7=1;
	noOfsol=1;
	i_order_update=0;
	
	// variables I added
	i_order=-1;
	N_order=0;
	percentOfOutliers = percentOfOutliersParam;
	if (percentOfOutliers<0 || percentOfOutliers > 1){
		percentOfOutliers = 1;
	}
	gr_sz=0;
	OK=0;
	sam=0;
	randVar = 0;
	stop=0;
	NN=0;
	InGr_N=0;
	repeatCount=0;
	prevInGr_N=0;
	cont=0;

	gr=myMathHelper.zeros(N,1);
	maxInProb = myMathHelper.zeros(probLiran.numOfRows,1);
	taken = new int[N];

	ePointInput = myMathHelper.zeros(N*4,4);
	pn1 = myMathHelper.zeros(N*4,4);
	pn2 = myMathHelper.zeros(N*4,4);
	probsAndIndexes = new Beem::ProbsAndIndexes[probLiran.numOfRows];

	v1 = new double[3];
	v2 = new double[3];
	v1_1 = new double[3];
	v2_1 = new double[3];
	v1_2 = new double[3];
	v2_2 = new double[3];

	InGr=myMathHelper.zeros(N,1);
	maxInGrCur=myMathHelper.zeros(N,1);
	maxInGr=myMathHelper.zeros(N,1);

	T1 = myMathHelper.zeros(3,3);
	T2 = myMathHelper.zeros(3,3);

	A = myMathHelper.zeros(pn1.numOfRows,9);
	vHelper = myMathHelper.zeros(10,10);
	FtTemp = myMathHelper.zeros(3,3);
	Ft = myMathHelper.zeros(3,3);
}

void Beem::exploitation()
{
	gotPin = 0;
	while (Ngold >0)
	{
		iterDD++;
		double pInVal = Pin;
		Ngold=Ngold-1;
		
		setMaxInProb(maxInGrCur);
		//maxInProb = myMathHelper.createSubMatrixVector(probLiran,maxInGrCur);
		//maxInProb = myMathHelper.divideInScalar(maxInProb,myMathHelper.findMaxInMatrix(maxInProb));
		gr_sz=max((int)floor((double)(maxInGrCur_N/2)),NgrSam);
		if (pInVal==1)
		{	
			gr_sz=min(gr_sz,20);
		} else{
			gr_sz=min(gr_sz,14);
		}
		//gr=myMathHelper.zeros(gr_sz,1);
		gr.setNumOfRowsAndCols(gr_sz , 1);
		int groupSize = gr_sz;
		if (pInVal==1)
		{
			groupSize--;
		}

		raffleAndCreateGr(groupSize , maxInGrCur_N , maxInProb , maxInGrCur);
		
		if (pInVal==1)
		{
			gr.getCell(gr_sz-1,0) = vec_order.getCell(i_order,0);
		}
		
		estimateF();
		buildInliersGroup();

		exploitationDecisionsMaker();
	}
}

void Beem::finalLocalExploration()
{
	iterDD++;
	//updateOrderOutput = update_order(maxInGr, probLiran);
	updateOrderOutput = update_order();
	vec_order = updateOrderOutput.vec_order;
	N_order = updateOrderOutput.N_order;
	//i_order = updateOrderOutput.i_order;
	//i_order++;
	int loopCounter=0;
	for (i_order=0 ; i_order<((int)floor(N_order * percentOfOutliers)) ; i_order++)
	{
		loopCounter++;
		iterDD++;
		if(i_order_update)
		{
			i_order_update=0;
			i_order=0;
			maxPin_N=NgrSam*2;
		}
		iter++;
		gotPin=1;
		
		setMaxInProb(maxInGr);
		//maxInProb = myMathHelper.createSubMatrixVector(probLiran,maxInGr);
		////maxInProb = myMathHelper.divideInScalar(maxInProb,myMathHelper.findMaxInMatrix(maxInProb));
		//maxInProb.assign(myMathHelper.divideInScalar(maxInProb,myMathHelper.findMaxInMatrix(maxInProb)));
		gr_sz=max((int)(floor(double(maxInGr_N/2)+1)),NgrSam);
		gr_sz=min(gr_sz,20);
		//gr=myMathHelper.zeros(gr_sz,1);
		gr.setNumOfRowsAndCols(gr_sz,1);
		raffleAndCreateGr(gr_sz-1 , maxInGr_N , maxInProb , maxInGr);
		
		/*adding the last element of the gr group from the outliers group. 
		  the next outlier is choosen according to the ordering */
		gr.getCell(gr_sz-1,0) = vec_order.getCell(i_order,0);


		estimateF();
		buildInliersGroup();
		
		//if (checkIfFoundBiggerInlierGroupAndUpdateModels())
		finalLocalExplorationDecisionsMaker();
		if (Ngold>0)
		{
			exploitation();
			//add i_order update  +  update vec_order recalculate
		}
	}			
	cout << "# of times final Local Exploration loop happend " << loopCounter << endl;
}

void Beem::setMaxInProb(MyMath::MyData& maxInGrIndexes)
{
	double maxInProbVal = 0;
	double probVal = 0;
	for (int i=0 ; i<maxInGrIndexes.numOfRows ; i++)
	{
		probVal = probLiran.getCell((int)maxInGrIndexes.getCell(i,0),0);
		maxInProb.getCell(i,0) = probVal;
		if (probVal > maxInProbVal)
		{
			maxInProbVal = probVal;
		}
	}
	for (int i=0 ; i<maxInGr.numOfRows ; i++)
	{
		maxInProb.getCell(i,0) /= maxInProbVal;
	}
}

void Beem::localExploration()
{
	//cout << "Starting local exploration " << endl;
	gotPin=1;
	outCor=myMathHelper.addScalar(myMathHelper.zeros(N,1),1); //outCor=ones(N,1);
	myMathHelper.setScalarValueInIndexes(outCor,maxInGr,0);//outCor(maxInGr)=0;
	outCor = myMathHelper.findIndexesInMatrix(outCor);
	outProb=myMathHelper.createSubMatrixVector(probLiran,outCor);
	outProb=myMathHelper.divideInScalar(outProb,myMathHelper.findMaxInMatrix(outProb));
	
	//maxInProb=myMathHelper.createSubMatrixVector(probLiran,maxInGr);
	//maxInProb=myMathHelper.divideInScalar(maxInProb,myMathHelper.findMaxInMatrix(maxInProb));
	setMaxInProb(maxInGr);
	
	gr_sz=max((int)(floor((double)maxInGr_N/2)+1),NgrSam);
	
	gr_sz=min(gr_sz,14);
	//gr=myMathHelper.zeros(gr_sz,1);
	gr.setNumOfRowsAndCols(gr_sz,1);
	
	raffleAndCreateGr(gr_sz-1 , maxInGr_N , maxInProb , maxInGr);
	
	/*adding the last element of the gr group from the outliers group*/
	NN=outCor.numOfRows;
	sam=(int)floor((double)myRandomGenerator()*NN);
	while (!(myRandomGenerator()<=outProb.getCell(sam,0)))
	{
		sam=(int)floor((double)myRandomGenerator()*NN);
	}
	gr.getCell(gr_sz-1,0)=outCor.getCell(sam,0);
	
	estimateF();

	buildInliersGroup();

	localExplorationDecisionsMaker();
	//if (checkIfFoundBiggerInlierGroupAndUpdateModels())
	if (Ngold>0)
	{
		exploitation();
	}
}

void Beem::globalExploration()
{
	//cout << "Starting global exploration " << endl;
	//gr=myMathHelper.zeros(NgrSam,1);
	gr.setNumOfRowsAndCols(NgrSam , 1);
	//cout << "Start raffle and create Gr"<<endl;
	raffleAndCreateGr(NgrSam , N , probLiran );
	//cout << "gr : " << gr.matrix[0][0] << " " << gr.matrix[1][0] <<endl;
	//cout << "random var " << randValuesIterator  << endl;
	//cout << "start estimate F" << endl;
	estimateF();
	//myMathHelper.printMatrix(F);
	//cout << "Start build inliers group"<<endl;
	buildInliersGroup();
	//cout << "Finish build inliers group" <<endl;

	globalExplorationDecisionsMaker();
	//if (checkIfFoundBiggerInlierGroupAndUpdateModels())
	if (Ngold>0)
	{
		//cout << "global exploitation";
		exploitation();
	}
}


void Beem::raffleAndCreateGr(int newGroupSize , int currentInlierGroupSize , MyMath::MyData& probMatrix , MyMath::MyData& currentInliersGroup)
{
	int OK=0;
	//MyMath::MyData taken=myMathHelper.zeros(currentInlierGroupSize,1);
	//int* taken;
	//taken = new int[currentInlierGroupSize];
	for (int i=0 ; i<currentInlierGroupSize ; i++)
	{
		taken[i] = 0;
	}
	for (int i=0 ; i<(newGroupSize) ; i++)
	{
		OK=0;
		while (!OK)
		{
			//sam=(int)floor((double)myRandomGenerator()* (currentInlierGroupSize-1));
			sam=(int)floor((double)myRandomGenerator()* (currentInlierGroupSize));
			if (taken[sam]==0)
			//if (taken.getCell(sam,0)==0)
			{
				if (myRandomGenerator()<= probMatrix.getCell(sam,0))
				{
					OK=1;
				}
			}
		}
		taken[sam]=1;
		//taken.getCell(sam,0) = 1;
		gr.getCell(i,0)=currentInliersGroup.getCell(sam,0);
	}
	//delete taken;
}
void Beem::raffleAndCreateGr(int newGroupSize , int currentInlierGroupSize , MyMath::MyData& probMatrix)
{
	int OK=0;
	//MyMath::MyData taken=myMathHelper.zeros(currentInlierGroupSize,1);
	for (int i=0 ; i<currentInlierGroupSize ; i++)
	{
		taken[i] = 0;
	}
	//cout << "start raffle For loop with new group size = " << newGroupSize <<endl;
	for (int i=0 ; i<(newGroupSize) ; i++)
	{
		//cout << "For loop - index = " << i << endl;
		OK=0;
		double randTemp = 0;
		while (!OK)
		{
			//cout << "while loop" << endl;
			//sam=(int)floor((double)myRandomGenerator()* (currentInlierGroupSize-1));
			randTemp = myRandomGenerator();
			//sam=(int)floor((double)myRandomGenerator()* (currentInlierGroupSize));
			sam=(int)floor((double)randTemp* (currentInlierGroupSize));
			//cout << sam<<endl;
			//cout << "sam = " << sam << " , with rand val = " << randTemp << endl;
			//if (taken.getCell(sam,0)==0)
			//cout << taken[sam] << "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
			if (taken[sam]==0)
			{
				//if (myRandomGenerator()<= probMatrix.getCell(sam,0))
				randTemp = myRandomGenerator();
				//cout << "rand value = " << randTemp << " , probability value = " << probMatrix.getCell(sam,0) << endl;
				if (randTemp<= probMatrix.getCell(sam,0))
				{
					OK=1;
				}
			}
		}
		//cout << "finished while loop%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%" << endl;
		taken[sam]=1;
		gr.getCell(i,0)=sam;
	}
}
double Beem::myRandomGenerator()
{
	double randVar;
	//////randVar = rand() / RAND_MAX ;
	randVar = rand();
	randVar /= RAND_MAX;
	//randVar = randValues[randValuesIterator++];
	return randVar;
}

MyMath::MyData& Beem::NinEstCDF(MyMath::MyData& davidScoreCut)
{
	////cout << "start  NinEstCDF cells  "<< MyMath::MyData::cells << " nmats " << MyMath::MyData::nmats<<endl;
	MyMath::MyData& inIndexRef = myMathHelper.createMat("inIndexRef"); //load inIndexRef;
	//fixing inIndexRef to fit c++ indexing
	//inIndexRef = myMathHelper.addScalar(inIndexRef,-1);
	inIndexRef.addScalar(-1);
	MyMath::MyData& dsRef = myMathHelper.createMat("dsRef"); // load dsRef;
	int Ncor=davidScoreCut.numOfRows;
	double tr=0.8;
	// create outIndex
	//MyMath::MyData tmp=myMathHelper.addScalar(myMathHelper.zeros(1,dsRef.numOfRows),1);
	MyMath::MyData& tmp=myMathHelper.zeros(1,dsRef.numOfRows);
	tmp.addScalar(1);
	//tmp(inIndexRef)=0;
	myMathHelper.setScalarValueInIndexes(tmp,inIndexRef,0);
	MyMath::MyData& outIndex=myMathHelper.findEqualsToScalarIndexes(tmp,1);

	/*MyMath::MyData& dsRefIn = myMathHelper.createSubMatrixVectorSmallerOrEqToScalarVal(dsRef,inIndexRef,tr);
	MyMath::MyData& dsRefOut = myMathHelper.createSubMatrixVectorSmallerOrEqToScalarVal(dsRef,outIndex,tr);*/

	//dsRefIn=dsRef(inIndexRef);
	MyMath::MyData* dsRefInTmp;
	dsRefInTmp = &(myMathHelper.createSubMatrixVector(dsRef,inIndexRef));
	//dsRefOut=dsRef(outIndex);
	MyMath::MyData* dsRefOutTmp;
	dsRefOutTmp = &(myMathHelper.createSubMatrixVector(dsRef,outIndex));
	
	//dsRefIn=dsRefIn(find(dsRefIn<=tr));
	MyMath::MyData& dsRefIn=myMathHelper.createSubMatrixVector(*dsRefInTmp,myMathHelper.findSmallerOrEqualsToScalarIndexes(*dsRefInTmp,tr));
	delete dsRefInTmp;
	//dsRefOut=dsRefOut(find(dsRefOut<=tr));
	MyMath::MyData& dsRefOut=myMathHelper.createSubMatrixVector(*dsRefOutTmp,myMathHelper.findSmallerOrEqualsToScalarIndexes(*dsRefOutTmp,tr));
	delete dsRefOutTmp;

	int Nin=dsRefIn.numOfRows;
	int Nout=dsRefOut.numOfRows;

	//clear dsRef;  line 25  
	
	int N=100;
	MyMath::MyData& A=myMathHelper.zeros(N+1,1);
	MyMath::MyData b=A;
	//MyMath::MyData b=myMathHelper.copyMatrix(A);
	double pos=0;
	double fx=0;
	double fi=0;
	double fo=0;
	for ( int i=0 ; i<(N+1) ; i++)
	{
		pos=((double)(i+1)/(N+1))*tr;
		//fx=sum(davidScoreCut<=pos)/Ncor;
		//fx=(myMathHelper.sumMatrix(myMathHelper.findSmallerOrEqualThenScalar(davidScoreCut,pos))).getCell(0,0)/Ncor;
		//
		fx=0;
		for (int j=0 ; j<davidScoreCut.numOfRows ; j++)
		{
			if (davidScoreCut.getCell(j,0) <= pos)
			{
				fx++;
			}
		}
		fx /= Ncor;
		//
		//fi=sum(dsRefIn<=pos)/Nin;
		//fi=(myMathHelper.sumMatrix(myMathHelper.findSmallerOrEqualThenScalar(dsRefIn,pos))).getCell(0,0)/Nin;
		//
		fi=0;
		for (int j=0 ; j<dsRefIn.numOfRows ; j++)
		{
			if (dsRefIn.getCell(j,0) <= pos)
			{
				fi++;
			}
		}
		fi /= Nin;
		//
		//fo=sum(dsRefOut<=pos)/Nout;
		//fo=(myMathHelper.sumMatrix(myMathHelper.findSmallerOrEqualThenScalar(dsRefOut,pos))).getCell(0,0)/Nout;
		//
		fo=0;
		for (int j=0 ; j<dsRefOut.numOfRows ; j++)
		{
			if (dsRefOut.getCell(j,0) <= pos)
			{
				fo++;
			}
		}
		fo /= Nout;
		//
		A.getCell(i,0)=fi-fo;
		b.getCell(i,0)=fx-fo;
	}
	 
	double alpha = 0;
	
	double *x = myMathHelper.getColumnAsArray(A,0);
	
	double *y = myMathHelper.getColumnAsArray(b,0);
	
	double sum1=0;
	double sum2=0;
	for (int i=0 ; i<A.numOfRows ; i++)
	{
		sum1 += y[i]*x[i];
		sum2 += x[i]*x[i];
	
	}
	alpha  = sum1/sum2;
	
	double alphaMin=max(alpha,0.05);
	cout << "alpha " << alpha << " alphaMin " << alphaMin<<endl;
	MyMath::MyData& probLiran=myMathHelper.zeros(Ncor,1);
	double kernelSmooParam;
	double h = kernelSmooPrep(dsRefIn);
	double hDsRefOut = kernelSmooPrep(dsRefOut);
	for (int i=0 ; i<Ncor ; i++)
	{
		pos=davidScoreCut.getCell(i,0);
		kernelSmooParam = kernelSmoo(pos,dsRefIn,h);
		//probLiran.getCell(i,0)=alphaMin*kernelSmoo(pos,dsRefIn)/(alphaMin*kernelSmoo(pos,dsRefIn)+(1-alphaMin)*kernelSmoo(pos,dsRefOut));
		probLiran.getCell(i,0)=alphaMin*kernelSmooParam/(alphaMin*kernelSmooParam+(1-alphaMin)*kernelSmoo(pos,dsRefOut,hDsRefOut));
	}
	//epsilon=alpha;
	//
	////cout << "end  NinEstCDF cells  "<< MyMath::MyData::cells << " nmats " << MyMath::MyData::nmats<<endl;

	
	for (int i=0;i<inIndexRef.allocatedNumOfRows;i++)
	{
		delete inIndexRef.matrix[i];
	}

	delete inIndexRef.matrix;

	for (int i=0;i<dsRef.allocatedNumOfRows;i++)
	{
		delete dsRef.matrix[i];
	}

	delete dsRef.matrix;

	return probLiran;
}

double Beem::kernelSmoo(double v ,MyMath::MyData A)
{
	int n=max(A.numOfRows , A.numOfCols);
	//  double h=(4*std(A)^5/3/n)^(1/5); 
	double stdA = myMathHelper.matrixStd(A);
	double h = pow(((4*pow(stdA,5))/3/n) , 1.0/5.0);

	//del=1-(abs(A-v))/h;
	MyMath::MyData del=myMathHelper.addScalar(myMathHelper.mulInScalar(myMathHelper.divideInScalar(myMathHelper.absMatrix(myMathHelper.addScalar(A,-1*v)),h),-1),1);
	MyMath::MyData big=myMathHelper.findBiggerThenScalar(del,0);
	double x=(myMathHelper.sumMatrix(myMathHelper.pointMatrixMul(big,del)).getCell(0,0))/n/h;
	return x;
}

double Beem::kernelSmooPrep(MyMath::MyData& A)
{
	int n=max(A.numOfRows , A.numOfCols);
	//  double h=(4*std(A)^5/3/n)^(1/5); 
	double stdA = myMathHelper.matrixStd(A);
	double h = pow(((4*pow(stdA,5))/3/n) , 1.0/5.0);
	return h;
}

double Beem::kernelSmoo(double v ,MyMath::MyData& A, double h)
{
	/*int n=max(A.numOfRows , A.numOfCols);
	//del=1-(abs(A-v))/h;
	//MyMath::MyData del=myMathHelper.addScalar(myMathHelper.mulInScalar(myMathHelper.divideInScalar(myMathHelper.absMatrix(myMathHelper.addScalar(A,-1*v)),h),-1),1);
	MyMath::MyData del= myMathHelper.copyMatrix(A);
	myMathHelper.addScalar2(del,-1*v);
	myMathHelper.absMatrix2(del);
	myMathHelper.divideInScalar2(del,h);
	myMathHelper.mulInScalar2(del,-1);
	myMathHelper.addScalar2(del,1);
	
	MyMath::MyData big=myMathHelper.findBiggerThenScalar(del,0);
	double x=(myMathHelper.sumMatrix(myMathHelper.pointMatrixMul(big,del)).getCell(0,0))/n/h;
	return x;*/
	double del = 0;
	double delTmp = 0;
	for (int i=0; i<A.numOfRows ; i++)
	{
		delTmp = 1 - ((abs(A.getCell(i,0)-v))/h);
		if (delTmp>0)
		{
			del += delTmp;
		}
	}
	return del/A.numOfRows/h;
}

void Beem::cr_outCDF(int N,MyMath::MyData outPDF , Beem::Cr_outCDF_Output& result)
{
	//Cr_outCDF_Output result;
	//outPDF=myMathHelper.roundMatrixValues(myMathHelper.addScalar(myMathHelper.mulInScalar(outPDF,N),0.49));
	//
	for (int i=0; i<outPDF.numOfRows ; i++)
	{
		outPDF.getCell(i,0) = floor((outPDF.getCell(i,0) * N + 0.49) + 0.5);
	}
	//
	result.maxNoGrOut=(int)floor((myMathHelper.findMaxInMatrix(outPDF)) + 0.5);
	result.outCdf=myMathHelper.zeros(N,1);
	double tmpSum = 0;
	for (int i=0 ; i<N ; i++)
	{
		//outCDF(i)=sum(outPDF<i)/size(outPDF,1);
		//result.outCdf.getCell(i,0)=(myMathHelper.sumMatrix(myMathHelper.findSmallerThenScalar(outPDF,i+1))).getCell(0,0)/outPDF.numOfRows;
		for (int j=0 ; j<outPDF.numOfRows ; j++)
		{
			if (outPDF.getCell(j,0) < i+1)
			{
				tmpSum++;
			}
		}
		result.outCdf.getCell(i,0) = tmpSum / outPDF.numOfRows;
		tmpSum = 0 ;
	}
	//return result;
}

double Beem::calcPin(MyMath::MyData outCdf,int iter,int maxGrNo,int maxNoGrOut,int updatePin)
{
	double sigmaProb = 0;
	if (maxGrNo<=1)
	{
		sigmaProb=0;
	} else
	{
		sigmaProb=outCdf.getCell(maxGrNo-1,0);
	}
	//double Pin=0;//// int Pin=binopdf(0,iter,1-sigmaProb); ////????
	double Pin = _itayUtil.binomial_pdf(0, iter, 1-sigmaProb );
	/*if(Pin == NULL) //TODO: check  ?
	{
		Pin=1;
	}*/
	if (updatePin==0)
	{
		Pin=0;
	}
	return Pin;
}

//Beem::UpdateOrderOutput Beem::update_order(MyMath::MyData maxInGr, MyMath::MyData probLiran1)
Beem::UpdateOrderOutput Beem::update_order()
{
	
	int sizeOfResult = probLiran.numOfRows - maxInGr.numOfRows;
	//Beem::ProbsAndIndexes* probsAndIndexes;
	//probsAndIndexes = new Beem::ProbsAndIndexes[sizeOfResult];
	int index = 0;
	int index1 = 0;
	//
	double* arr;
	arr = new double[maxInGr.numOfRows];
	for (int i=0 ; i<maxInGr.numOfRows ; i++)
	{
		arr[i] = maxInGr.matrix[i][0];
	}
	sort(arr,arr+maxInGr.numOfRows);
	//
	for (int i=0 ; i<probLiran.numOfRows ; i++)
	{
		//if (maxInGr.getCell(index1,0) != i)
		if (arr[index1]!=i)
		{
		  probsAndIndexes[index++] = ProbsAndIndexes(-1*probLiran.getCell(i,0),i);
		} else
		{
			index1++;
			if (index1 >= maxInGr.numOfRows)
				index1=0;
		}
	}
	delete[] arr;
	ProbsAndIndexes* pp = probsAndIndexes + sizeOfResult;
stable_sort(probsAndIndexes,pp);
	
	UpdateOrderOutput result;
	result.vec_order = myMathHelper.zeros(sizeOfResult,1);
	for (int i=0 ; i<sizeOfResult ; i++)
	{
	  result.vec_order.getCell(i,0) = probsAndIndexes[i].index;
	}

	//delete[] probsAndIndexes;

	
	//
	////MyMath::MyData probLiran = myMathHelper.copyMatrix(probLiran1);
	//MyMath::MyData probLiran1 = probLiran;
	////UpdateOrderOutput result;
	////probLiran(maxInGr)=0;
	//myMathHelper.setScalarValueInIndexes(probLiran1,maxInGr,0);
	////tmp=find(probLiran);
	//MyMath::MyData tmp = myMathHelper.findIndexesInMatrix(probLiran1);
	////ar=[tmp, -probLiran(tmp)];
	//MyMath::MyData ar = myMathHelper.copyMatrix(tmp);
	//ar = myMathHelper.concatMatricesMoreColumns(ar , (myMathHelper.mulInScalar(myMathHelper.createNewMatrixVectorAccordingToIndexes(probLiran1,tmp) , -1)));
	//ar = myMathHelper.sortRows(ar,2);
	//result.vec_order = myMathHelper.getColumn(ar,0);
	result.N_order = result.vec_order.numOfRows;
	result.i_order = -1;

	return result;
}

void Beem::normalizePic(MyMath::MyData& p , int arg , MyMath::MyData& T , MyMath::MyData& pn)
{
	double* ori = new double[2];
	//find p mean
	ori[0] = 0; ori[1] = 0;
	for (int i=0 ; i<p.numOfRows ; i++)
	{
		ori[0] += p.getCell(i,0);
		ori[1] += p.getCell(i,1);
	}
	ori[0] /= p.numOfRows;
	ori[1] /= p.numOfRows;

	double sum=0;
	for (int  i=0 ; i<p.numOfRows ; i++)
	{
		sum += sqrt(SQR((p.getCell(i,0)-ori[0]))+SQR((p.getCell(i,1)-ori[1])));
	}
	double par=sqrt(2.0)/(sum/p.numOfRows);
	
	if (arg==1)
	{
		//T=[par  0   -ori(1)*par  ;  0   par -ori(2)*par   ;   0   0   1];
		T.getCell(0,0) = par;
		T.getCell(0,1) = 0;
		T.getCell(0,2) = (-1)*ori[0]*par;
		T.getCell(1,0) = 0;
		T.getCell(1,1) = par;
		T.getCell(1,2) = (-1)*ori[1]*par;
		T.getCell(2,0) = 0;
		T.getCell(2,1) = 0;
		T.getCell(2,2) = 1;
	} else
	{
		//T=eye(3);
		T.getCell(0,0) = 1;
		T.getCell(1,1) = 1;
		T.getCell(2,2) = 1;
	}

	for (int i=0 ; i<p.numOfRows ; i++)
	{
		pn.getCell(i,0)= T.getCell(0,0)*p.getCell(i,0) + T.getCell(0,1)*p.getCell(i,1) + T.getCell(0,2);
		pn.getCell(i,1)= T.getCell(1,0)*p.getCell(i,0) + T.getCell(1,1)*p.getCell(i,1) + T.getCell(1,2);
	}
}

MyMath::MyData Beem::epoint(MyMath::MyData& M,int sing_cons)
{
	int colToRemove=0;
	MyMath::MyData& p1=myMathHelper.getColumns(M,0,1);
	MyMath::MyData& p2=myMathHelper.getColumns(M,2,3);
	
	int arg=1;
	int NoOfPoints=p1.numOfRows;

	// Normalize pic1
	T1.setZeros();
	pn1.setNumOfRowsAndCols(p1.numOfRows,2);
	pn1.setZeros();
	normalizePic(p1,arg,T1,pn1);
	// Normalize pic2
	T2.setZeros();
	pn2.setNumOfRowsAndCols(p1.numOfRows,2);
	pn2.setZeros();
	normalizePic(p2,arg,T2,pn2);

	//linear solution
	//calc A
	A.setNumOfRowsAndCols(pn1.numOfRows+1,9+1);
	for (int i=1; i<A.numOfRows ; i++)
	{
		A.getCell(i,0) = 0;
		A.getCell(i,1) = pn1.getCell(i-1,0) * pn2.getCell(i-1,0);
		A.getCell(i,2) = pn1.getCell(i-1,1) * pn2.getCell(i-1,0);
		A.getCell(i,3) = pn2.getCell(i-1,0);
		A.getCell(i,4) = pn1.getCell(i-1,0) * pn2.getCell(i-1,1);
		A.getCell(i,5) = pn1.getCell(i-1,1) * pn2.getCell(i-1,1);
		A.getCell(i,6) = pn2.getCell(i-1,1);
		A.getCell(i,7) = pn1.getCell(i-1,0);
		A.getCell(i,8) = pn1.getCell(i-1,1);
		A.getCell(i,9) = 1;
	}
	for (int i=0 ; i<A.numOfCols ; i++)
	{
		A.getCell(0,i) = 0;
	}
	// do SVD

	
	//--
	
	double* w = new double[9+1]; 
	
	vHelper.setZeros();

	_itayUtil.dsvdcmp(A.matrix, A.numOfRows-1, A.numOfCols-1, w, vHelper.matrix);

	/*cout << "A(known as U):" << endl;
	myMathHelper.printMatrix(A);
	cout << "V: " <<endl;
	myMathHelper.printMatrix(vHelper);
	cout << "w: " << endl;
	for (int i=0;i<10;i++)
	{
		cout << w[i] << " ";
	}*/

	// sorting V and w according to w
	for (int i=0; i<vHelper.numOfCols ; i++)
	{
		vHelper.getCell(0,i)=w[i];
	}
	
	sort(w+1,w+10);

	//calc Ft
	//MyMath::MyData Ft = myMathHelper.zeros(3,3);
	Ft.setZeros();
	for (int i=vHelper.numOfCols-1 ; i>=0 ; i--)
	{
		if (w[1] == vHelper.getCell(0,i))
		{
			Ft.getCell(0,0)=vHelper.getCell(1,i);
			Ft.getCell(0,1)=vHelper.getCell(2,i);
			Ft.getCell(0,2)=vHelper.getCell(3,i);
			Ft.getCell(1,0)=vHelper.getCell(4,i);
			Ft.getCell(1,1)=vHelper.getCell(5,i);
			Ft.getCell(1,2)=vHelper.getCell(6,i);
			Ft.getCell(2,0)=vHelper.getCell(7,i);
			Ft.getCell(2,1)=vHelper.getCell(8,i);
			Ft.getCell(2,2)=vHelper.getCell(9,i);
			break;
		}
	}
	//--
	if (sing_cons==1)
	{
		//MyMath::MyData U1 = Ft;
		MyMath::MyData U1 = myMathHelper.zeros(4,4);
		for (int i=1; i<4 ; i++)
		{
			for (int j=1 ; j<4 ; j++)
			{
				U1.getCell(i,j) = Ft.getCell(i-1,j-1);
			}
		}
		MyMath::MyData S1 = myMathHelper.zeros(3,3);
		double* w1 = new double[3+1]; 
		MyMath::MyData V1 = myMathHelper.zeros(4,4);
		//TODO: [U,S,V] = svd(Ft);
		_itayUtil.dsvdcmp(U1.matrix, U1.numOfRows-1, U1.numOfCols-1, w1, V1.matrix);

		//--
		int* wIndexes = new int[3];

		//set wIndexes vector according to decreasing sort
		if (w1[1]>w1[2] && w1[1]>w1[3]) {wIndexes[0]=1; wIndexes[1]=2; wIndexes[2]=3; if (w1[3]>w1[2]){wIndexes[1]=3; wIndexes[2]=2;}}
		else if (w1[2]>w1[1] && w1[2]>w1[3]) {wIndexes[0]=2; wIndexes[1]=1; wIndexes[2]=3;if (w1[3]>w1[1]){wIndexes[1]=3; wIndexes[2]=1;}}
		else {wIndexes[0]=3; wIndexes[1]=1; wIndexes[2]=2;if (w1[2]>w1[1]){wIndexes[1]=2; wIndexes[2]=1;}};
		
		//doing Ft = U1*S1
		FtTemp.getCell(0,0)=U1.getCell(1,wIndexes[0])*w1[wIndexes[0]];
		FtTemp.getCell(1,0)=U1.getCell(2,wIndexes[0])*w1[wIndexes[0]];
		FtTemp.getCell(2,0)=U1.getCell(3,wIndexes[0])*w1[wIndexes[0]];
		
		FtTemp.getCell(0,1)=U1.getCell(1,wIndexes[1])*w1[wIndexes[1]];
		FtTemp.getCell(1,1)=U1.getCell(2,wIndexes[1])*w1[wIndexes[1]];
		FtTemp.getCell(2,1)=U1.getCell(3,wIndexes[1])*w1[wIndexes[1]];
		
		FtTemp.getCell(0,2)=0;
		FtTemp.getCell(1,2)=0;
		FtTemp.getCell(2,2)=0;
	/*	Ft.getCell(0,2)=U1.getCell(1,wIndexes[2])*w1[wIndexes[2]];
		Ft.getCell(1,2)=U1.getCell(2,wIndexes[2])*w1[wIndexes[2]];
		Ft.getCell(2,2)=U1.getCell(3,wIndexes[2])*w1[wIndexes[2]];*/
	//	myMathHelper.printMatrix(Ft);
		//doing Ft = Ft*V1
		// attempt start
		Ft.getCell(0,0) = FtTemp.getCell(0,0) * V1.getCell(1,wIndexes[0]) + FtTemp.getCell(0,1) * V1.getCell(1,wIndexes[1]);
		Ft.getCell(1,0) = FtTemp.getCell(1,0) * V1.getCell(1,wIndexes[0]) + FtTemp.getCell(1,1) * V1.getCell(1,wIndexes[1]);
		Ft.getCell(2,0) = FtTemp.getCell(2,0) * V1.getCell(1,wIndexes[0]) + FtTemp.getCell(2,1) * V1.getCell(1,wIndexes[1]);
		Ft.getCell(0,1) = FtTemp.getCell(0,0) * V1.getCell(2,wIndexes[0]) + FtTemp.getCell(0,1) * V1.getCell(2,wIndexes[1]);
		Ft.getCell(1,1) = FtTemp.getCell(1,0) * V1.getCell(2,wIndexes[0]) + FtTemp.getCell(1,1) * V1.getCell(2,wIndexes[1]);
		Ft.getCell(2,1) = FtTemp.getCell(2,0) * V1.getCell(2,wIndexes[0]) + FtTemp.getCell(2,1) * V1.getCell(2,wIndexes[1]);
		Ft.getCell(0,2) = FtTemp.getCell(0,0) * V1.getCell(3,wIndexes[0]) + FtTemp.getCell(0,1) * V1.getCell(3,wIndexes[1]);
		Ft.getCell(1,2) = FtTemp.getCell(1,0) * V1.getCell(3,wIndexes[0]) + FtTemp.getCell(1,1) * V1.getCell(3,wIndexes[1]);
		Ft.getCell(2,2) = FtTemp.getCell(2,0) * V1.getCell(3,wIndexes[0]) + FtTemp.getCell(2,1) * V1.getCell(3,wIndexes[1]);
		/*cout << "v1: " <<endl;
		myMathHelper.printMatrix(V1);
		cout << "Ft: " <<endl;
		myMathHelper.printMatrix(Ft);
		cout << "dd";*/
		// attempt end
		// start remove
		//w1[0] = -100000;
		//for (int i=0; i<V1.numOfCols ; i++)
		//{
		//	V1.getCell(0,i)=w1[i];
		//}
		//V1 = myMathHelper.sortColsDecreasing(V1,1);
		//V1 = myMathHelper.removePadFirstRowAndLastCol(V1);
		//Ft=myMathHelper.mulMatrices(Ft,myMathHelper.transposeMatrix(V1));
		// end remove

		//--

		////sort(w1+1,w1+4);
		//// sorting U according to w
		//w1[0] = -100000;
		//for (int i=0; i<U1.numOfCols ; i++)
		//{
		//	U1.getCell(0,i)=w1[i];
		//}
		//U1 = myMathHelper.sortColsDecreasing(U1,1);
		//U1 = myMathHelper.removePadFirstRowAndLastCol(U1);
		//// sorting V and w according to w
		////
		//
		//for (int i=0; i<V1.numOfCols ; i++)
		//{
		//	V1.getCell(0,i)=w1[i];
		//}
		//V1 = myMathHelper.sortColsDecreasing(V1,1);
		//for (int i=0 ; i<V1.numOfRows ; i++)
		//{
		//	w1[i] = V1.getCell(0,i);
		//}
		////
		//V1 = myMathHelper.removePadFirstRowAndLastCol(V1);

		//S1.getCell(0,0)=w1[0];
		//S1.getCell(1,1)=w1[1];

		//S1.getCell(2,2)=0;
		//Ft=myMathHelper.mulMatrices(myMathHelper.mulMatrices(U1,S1),myMathHelper.transposeMatrix(V1));
	}
//cout << "print Ft : " <<endl;
//	myMathHelper.printMatrix(Ft);
	//F=T2'*Ft*T1;
	F=myMathHelper.mulMatrices(myMathHelper.mulMatrices(myMathHelper.transposeMatrix(T2),Ft),T1);
	//F=F/norm(F);
	F=myMathHelper.divideInScalar(F,myMathHelper.matrixNorm(F));  
	//cout << "print F : " <<endl;
	//myMathHelper.printMatrix(F);
	return F;
}

int Beem::spoint(MyMath::MyData M, int sol, int sing_cons)
{
	int colToRemove = 0;
	//pic1=M(:,1:2);
	//pic2=M(:,3:4);
	MyMath::MyData pic1 = myMathHelper.getColumns(M,0,1);
	MyMath::MyData pic2 = myMathHelper.getColumns(M,2,3);
	//A=zeros(7,9);
	MyMath::MyData A=myMathHelper.zeros(7,9);
	//A(:,1)=times(pic1(:,1),pic2(:,1));		//f11
	myMathHelper.copyColToMatrixColInIndex(A,myMathHelper.pointMatrixMul(myMathHelper.getColumn(pic1,0),myMathHelper.getColumn(pic2,0)),0);
	//A(:,4)=times(pic1(:,2),pic2(:,1));		%//f12
	myMathHelper.copyColToMatrixColInIndex(A,myMathHelper.pointMatrixMul(myMathHelper.getColumn(pic1,1),myMathHelper.getColumn(pic2,0)),3);
	//	A(:,7)=pic2(:,1);			%	//f13
	myMathHelper.copyColToMatrixColInIndex(A,myMathHelper.getColumn(pic2,0),6);
	//	A(:,2)=times(pic1(:,1),pic2(:,2));		%//f21
	myMathHelper.copyColToMatrixColInIndex(A,myMathHelper.pointMatrixMul(myMathHelper.getColumn(pic1,0),myMathHelper.getColumn(pic2,1)),1);
	//	A(:,5)=times(pic1(:,2),pic2(:,2));		%//f22
	myMathHelper.copyColToMatrixColInIndex(A,myMathHelper.pointMatrixMul(myMathHelper.getColumn(pic1,1),myMathHelper.getColumn(pic2,1)),4);
	//	A(:,8)=pic2(:,2);	%			//f23
	myMathHelper.copyColToMatrixColInIndex(A,myMathHelper.getColumn(pic2,1),7);
	//	A(:,3)=pic1(:,1);		%		//f31
	myMathHelper.copyColToMatrixColInIndex(A,myMathHelper.getColumn(pic1,0),2);
	//	A(:,6)=pic1(:,2);			%	//f32
	myMathHelper.copyColToMatrixColInIndex(A,myMathHelper.getColumn(pic1,1),5);
	//	A(:,9)=1;
	myMathHelper.copyColToMatrixColInIndex(A,(myMathHelper.addScalar(myMathHelper.zeros(A.numOfRows,1),1)),5);


	//[U,S,V] = svd(A);
	MyMath::MyData U = myMathHelper.copyMatrix(A);  
	double* w = new double[8+1]; 
	MyMath::MyData V = myMathHelper.zeros(9,9); 
	U = myMathHelper.padFirstRowAndCol(U);
	V = myMathHelper.padFirstRowAndCol(V);
	_itayUtil.dsvdcmp(U.matrix, U.numOfRows, U.numOfCols, w, V.matrix);
	colToRemove = findSmallestValueInW(w , 9);
	U = myMathHelper.removeCol(U,colToRemove);
	// sorting U according to w
	w[0] = -100000;
	for (int i=0; i<U.numOfCols ; i++)
	{
		U.getCell(0,i)=w[i];
	}
	U = myMathHelper.sortColsDecreasing(U,1);
	U = myMathHelper.removePadFirstRowAndLastCol(U);
	//
	// sorting V and w according to w
	for (int i=0; i<V.numOfCols ; i++)
	{
		V.getCell(0,i)=w[i];
	}
	V = myMathHelper.sortColsDecreasing(V,1);
	for (int i=0 ; i<V.numOfRows ; i++)
	{
		w[i] = V.getCell(0,i);
	}
	//
	V = myMathHelper.removePadFirstRowAndLastCol(V);

	MyMath::MyData f=myMathHelper.getColumn(V,8);
	MyMath::MyData ff=myMathHelper.getColumn(V,7);

	double t5 = ff.getCell((1)+(1-1)*3,0)*ff.getCell((2)+(2-1)*3,0);
	double t9 = ff.getCell((1)+(3-1)*3,0)*ff.getCell((2)+(1-1)*3,0);
	double t21 = ff.getCell((1)+(3-1)*3,0)*ff.getCell((2)+(2-1)*3,0);
	double t25 = f.getCell((1)+(1-1)*3,0)*f.getCell((2)+(2-1)*3,0)*f.getCell((3)+(3-1)*3,0)-ff.getCell((1)+(3-1)*3,0)*ff.getCell((3)+(1-1)*3,0)*f.getCell((2)+(2-1)*3,0)-t5*ff.getCell((3)+(3-1)*3,0)-ff.getCell((2)+(1-1)*3,0)*f.getCell((1)+(3-1)*3,0)*f.getCell((3)+(2-1)*3,0)-t9*ff.getCell((3)+(2-1)*3,0)-ff.getCell((1)+(3-1)*3,0)*f.getCell((2)+(1-1)*3,0)*f.getCell((3)+(2-1)*3,0)+ff.getCell((3)+(1-1)*3,0)*f.getCell((1)+(3-1)*3,0)*f.getCell((2)+(2-1)*3,0)-f.getCell((1)+(2-1)*3,0)*f.getCell((2)+(1-1)*3,0)*f.getCell((3)+(3-1)*3,0)+ff.getCell((2)+(3-1)*3,0)*f.getCell((1)+(1-1)*3,0)*f.getCell((3)+(2-1)*3,0)-f.getCell((1)+(3-1)*3,0)*f.getCell((2)+(2-1)*3,0)*f.getCell((3)+(1-1)*3,0)+t21*ff.getCell((3)+(1-1)*3,0)+ff.getCell((2)+(3-1)*3,0)*ff.getCell((3)+(1-1)*3,0)*f.getCell((1)+(2-1)*3,0);
	double t28 = ff.getCell((1)+(1-1)*3,0)*ff.getCell((2)+(3-1)*3,0);
	double t32 = ff.getCell((1)+(2-1)*3,0)*ff.getCell((2)+(1-1)*3,0);
	double t46 = ff.getCell((1)+(2-1)*3,0)*ff.getCell((2)+(3-1)*3,0);
	double t50 = -ff.getCell((1)+(2-1)*3,0)*f.getCell((2)+(3-1)*3,0)*f.getCell((3)+(1-1)*3,0)-t28*f.getCell((3)+(2-1)*3,0)+ff.getCell((3)+(3-1)*3,0)*f.getCell((1)+(2-1)*3,0)*f.getCell((2)+(1-1)*3,0)-t32*f.getCell((3)+(3-1)*3,0)-ff.getCell((2)+(3-1)*3,0)*ff.getCell((3)+(2-1)*3,0)*f.getCell((1)+(1-1)*3,0)-ff.getCell((1)+(1-1)*3,0)*ff.getCell((3)+(2-1)*3,0)*f.getCell((2)+(3-1)*3,0)-ff.getCell((1)+(1-1)*3,0)*f.getCell((2)+(2-1)*3,0)*f.getCell((3)+(3-1)*3,0)+ff.getCell((1)+(1-1)*3,0)*ff.getCell((3)+(3-1)*3,0)*f.getCell((2)+(2-1)*3,0)+f.getCell((1)+(2-1)*3,0)*f.getCell((2)+(3-1)*3,0)*f.getCell((3)+(1-1)*3,0)+ff.getCell((1)+(2-1)*3,0)*f.getCell((2)+(1-1)*3,0)*f.getCell((3)+(3-1)*3,0)+t46*f.getCell((3)+(1-1)*3,0)+ff.getCell((2)+(2-1)*3,0)*f.getCell((1)+(3-1)*3,0)*f.getCell((3)+(1-1)*3,0);
	double t72 = -f.getCell((1)+(1-1)*3,0)*f.getCell((2)+(3-1)*3,0)*f.getCell((3)+(2-1)*3,0)+ff.getCell((1)+(2-1)*3,0)*ff.getCell((3)+(1-1)*3,0)*f.getCell((2)+(3-1)*3,0)-ff.getCell((3)+(1-1)*3,0)*f.getCell((1)+(2-1)*3,0)*f.getCell((2)+(3-1)*3,0)+ff.getCell((2)+(1-1)*3,0)*ff.getCell((3)+(2-1)*3,0)*f.getCell((1)+(3-1)*3,0)+t5*f.getCell((3)+(3-1)*3,0)-ff.getCell((3)+(3-1)*3,0)*f.getCell((1)+(1-1)*3,0)*f.getCell((2)+(2-1)*3,0)+ff.getCell((1)+(3-1)*3,0)*f.getCell((2)+(2-1)*3,0)*f.getCell((3)+(1-1)*3,0)+t32*ff.getCell((3)+(3-1)*3,0)+t9*f.getCell((3)+(2-1)*3,0)-t46*ff.getCell((3)+(1-1)*3,0)-ff.getCell((1)+(2-1)*3,0)*ff.getCell((3)+(3-1)*3,0)*f.getCell((2)+(1-1)*3,0)-ff.getCell((2)+(1-1)*3,0)*ff.getCell((3)+(3-1)*3,0)*f.getCell((1)+(2-1)*3,0);
	double t95 = -ff.getCell((3)+(2-1)*3,0)*f.getCell((1)+(3-1)*3,0)*f.getCell((2)+(1-1)*3,0)+ff.getCell((1)+(3-1)*3,0)*ff.getCell((3)+(2-1)*3,0)*f.getCell((2)+(1-1)*3,0)+f.getCell((1)+(3-1)*3,0)*f.getCell((2)+(1-1)*3,0)*f.getCell((3)+(2-1)*3,0)+ff.getCell((2)+(1-1)*3,0)*f.getCell((1)+(2-1)*3,0)*f.getCell((3)+(3-1)*3,0)-ff.getCell((2)+(3-1)*3,0)*f.getCell((1)+(2-1)*3,0)*f.getCell((3)+(1-1)*3,0)-ff.getCell((2)+(2-1)*3,0)*f.getCell((1)+(1-1)*3,0)*f.getCell((3)+(3-1)*3,0)+t28*ff.getCell((3)+(2-1)*3,0)+ff.getCell((2)+(2-1)*3,0)*ff.getCell((3)+(3-1)*3,0)*f.getCell((1)+(1-1)*3,0)+ff.getCell((1)+(1-1)*3,0)*f.getCell((2)+(3-1)*3,0)*f.getCell((3)+(2-1)*3,0)-t21*f.getCell((3)+(1-1)*3,0)-ff.getCell((2)+(2-1)*3,0)*ff.getCell((3)+(1-1)*3,0)*f.getCell((1)+(3-1)*3,0)+ff.getCell((3)+(2-1)*3,0)*f.getCell((1)+(1-1)*3,0)*f.getCell((2)+(3-1)*3,0);
	double co3=(t25+t50+t72+t95);

	t9 = ff.getCell((1)+(3-1)*3,0)*ff.getCell((2)+(2-1)*3,0);
	double t14 = ff.getCell((1)+(2-1)*3,0)*ff.getCell((2)+(1-1)*3,0);
	double t19 = ff.getCell((1)+(2-1)*3,0)*ff.getCell((2)+(3-1)*3,0);
	double t47 = ff.getCell((1)+(3-1)*3,0)*ff.getCell((2)+(1-1)*3,0);
	double t55 = -ff.getCell((3)+(1-1)*3,0)*f.getCell((1)+(3-1)*3,0)*f.getCell((2)+(2-1)*3,0)+ff.getCell((2)+(3-1)*3,0)*f.getCell((1)+(2-1)*3,0)*f.getCell((3)+(1-1)*3,0)-2.0*ff.getCell((2)+(3-1)*3,0)*ff.getCell((3)+(1-1)*3,0)*f.getCell((1)+(2-1)*3,0)+ff.getCell((2)+(2-1)*3,0)*f.getCell((1)+(1-1)*3,0)*f.getCell((3)+(3-1)*3,0)+ff.getCell((3)+(1-1)*3,0)*f.getCell((1)+(2-1)*3,0)*f.getCell((2)+(3-1)*3,0)-2.0*ff.getCell((2)+(2-1)*3,0)*ff.getCell((3)+(3-1)*3,0)*f.getCell((1)+(1-1)*3,0)+2.0*ff.getCell((2)+(1-1)*3,0)*ff.getCell((3)+(3-1)*3,0)*f.getCell((1)+(2-1)*3,0)+2.0*ff.getCell((1)+(3-1)*3,0)*ff.getCell((3)+(1-1)*3,0)*f.getCell((2)+(2-1)*3,0)-2.0*t47*f.getCell((3)+(2-1)*3,0)-ff.getCell((1)+(2-1)*3,0)*f.getCell((2)+(1-1)*3,0)*f.getCell((3)+(3-1)*3,0)+2.0*ff.getCell((1)+(2-1)*3,0)*ff.getCell((3)+(3-1)*3,0)*f.getCell((2)+(1-1)*3,0);
	double t77 = ff.getCell((1)+(1-1)*3,0)*ff.getCell((2)+(2-1)*3,0);
	double t86 = ff.getCell((1)+(1-1)*3,0)*ff.getCell((2)+(3-1)*3,0);
	double t107 = ff.getCell((1)+(3-1)*3,0)*f.getCell((2)+(1-1)*3,0)*f.getCell((3)+(2-1)*3,0)-2.0*ff.getCell((1)+(3-1)*3,0)*ff.getCell((3)+(2-1)*3,0)*f.getCell((2)+(1-1)*3,0)+2.0*t86*f.getCell((3)+(2-1)*3,0)+3.0*t77*ff.getCell((3)+(3-1)*3,0)+2.0*ff.getCell((2)+(3-1)*3,0)*ff.getCell((3)+(2-1)*3,0)*f.getCell((1)+(1-1)*3,0)-ff.getCell((2)+(3-1)*3,0)*f.getCell((1)+(1-1)*3,0)*f.getCell((3)+(2-1)*3,0)-ff.getCell((2)+(1-1)*3,0)*f.getCell((1)+(2-1)*3,0)*f.getCell((3)+(3-1)*3,0)-ff.getCell((2)+(2-1)*3,0)*f.getCell((1)+(3-1)*3,0)*f.getCell((3)+(1-1)*3,0)-ff.getCell((1)+(1-1)*3,0)*f.getCell((2)+(3-1)*3,0)*f.getCell((3)+(2-1)*3,0)-2.0*ff.getCell((2)+(1-1)*3,0)*ff.getCell((3)+(2-1)*3,0)*f.getCell((1)+(3-1)*3,0)-3.0*t86*ff.getCell((3)+(2-1)*3,0);
	double co2=(ff.getCell((1)+(1-1)*3,0)*f.getCell((2)+(2-1)*3,0)*f.getCell((3)+(3-1)*3,0)+2.0*ff.getCell((1)+(1-1)*3,0)*ff.getCell((3)+(2-1)*3,0)*f.getCell((2)+(3-1)*3,0)+2.0*ff.getCell((2)+(2-1)*3,0)*ff.getCell((3)+(1-1)*3,0)*f.getCell((1)+(3-1)*3,0)-3.0*t9*ff.getCell((3)+(1-1)*3,0)-ff.getCell((3)+(2-1)*3,0)*f.getCell((1)+(1-1)*3,0)*f.getCell((2)+(3-1)*3,0)-3.0*t14*ff.getCell((3)+(3-1)*3,0)-ff.getCell((1)+(3-1)*3,0)*f.getCell((2)+(2-1)*3,0)*f.getCell((3)+(1-1)*3,0)+3.0*t19*ff.getCell((3)+(1-1)*3,0)+ff.getCell((3)+(3-1)*3,0)*f.getCell((1)+(1-1)*3,0)*f.getCell((2)+(2-1)*3,0)+ff.getCell((3)+(2-1)*3,0)*f.getCell((1)+(3-1)*3,0)*f.getCell((2)+(1-1)*3,0)+t55-2.0*ff.getCell((1)+(2-1)*3,0)*ff.getCell((3)+(1-1)*3,0)*f.getCell((2)+(3-1)*3,0)+2.0*t9*f.getCell((3)+(1-1)*3,0)-2.0*t19*f.getCell((3)+(1-1)*3,0)+2.0*t14*f.getCell((3)+(3-1)*3,0)+ff.getCell((2)+(1-1)*3,0)*f.getCell((1)+(3-1)*3,0)*f.getCell((3)+(2-1)*3,0)+ff.getCell((1)+(2-1)*3,0)*f.getCell((2)+(3-1)*3,0)*f.getCell((3)+(1-1)*3,0)-2.0*ff.getCell((1)+(1-1)*3,0)*ff.getCell((3)+(3-1)*3,0)*f.getCell((2)+(2-1)*3,0)-ff.getCell((3)+(3-1)*3,0)*f.getCell((1)+(2-1)*3,0)*f.getCell((2)+(1-1)*3,0)+3.0*t47*ff.getCell((3)+(2-1)*3,0)-2.0*t77*f.getCell((3)+(3-1)*3,0)+t107);

	double t1 = ff.getCell((1)+(1-1)*3,0)*ff.getCell((2)+(2-1)*3,0);
	t5 = ff.getCell((1)+(1-1)*3,0)*ff.getCell((2)+(3-1)*3,0);
	double t13 = ff.getCell((1)+(2-1)*3,0)*ff.getCell((2)+(1-1)*3,0);
	double t17 = ff.getCell((1)+(2-1)*3,0)*ff.getCell((2)+(3-1)*3,0);
	t25 = -3.0*t1*ff.getCell((3)+(3-1)*3,0)+t1*f.getCell((3)+(3-1)*3,0)+3.0*t5*ff.getCell((3)+(2-1)*3,0)-t5*f.getCell((3)+(2-1)*3,0)-ff.getCell((1)+(1-1)*3,0)*ff.getCell((3)+(2-1)*3,0)*f.getCell((2)+(3-1)*3,0)+ff.getCell((1)+(1-1)*3,0)*ff.getCell((3)+(3-1)*3,0)*f.getCell((2)+(2-1)*3,0)+3.0*t13*ff.getCell((3)+(3-1)*3,0)-t13*f.getCell((3)+(3-1)*3,0)-3.0*t17*ff.getCell((3)+(1-1)*3,0)+t17*f.getCell((3)+(1-1)*3,0)+ff.getCell((1)+(2-1)*3,0)*ff.getCell((3)+(1-1)*3,0)*f.getCell((2)+(3-1)*3,0)-ff.getCell((1)+(2-1)*3,0)*ff.getCell((3)+(3-1)*3,0)*f.getCell((2)+(1-1)*3,0);
	double t26 = ff.getCell((1)+(3-1)*3,0)*ff.getCell((2)+(1-1)*3,0);
	double t30 = ff.getCell((1)+(3-1)*3,0)*ff.getCell((2)+(2-1)*3,0);
	t50 = -3.0*t26*ff.getCell((3)+(2-1)*3,0)+t26*f.getCell((3)+(2-1)*3,0)+3.0*t30*ff.getCell((3)+(1-1)*3,0)-t30*f.getCell((3)+(1-1)*3,0)-ff.getCell((1)+(3-1)*3,0)*ff.getCell((3)+(1-1)*3,0)*f.getCell((2)+(2-1)*3,0)+ff.getCell((1)+(3-1)*3,0)*ff.getCell((3)+(2-1)*3,0)*f.getCell((2)+(1-1)*3,0)+ff.getCell((2)+(1-1)*3,0)*ff.getCell((3)+(2-1)*3,0)*f.getCell((1)+(3-1)*3,0)-ff.getCell((2)+(1-1)*3,0)*ff.getCell((3)+(3-1)*3,0)*f.getCell((1)+(2-1)*3,0)-ff.getCell((2)+(2-1)*3,0)*ff.getCell((3)+(1-1)*3,0)*f.getCell((1)+(3-1)*3,0)+ff.getCell((2)+(2-1)*3,0)*ff.getCell((3)+(3-1)*3,0)*f.getCell((1)+(1-1)*3,0)+ff.getCell((2)+(3-1)*3,0)*ff.getCell((3)+(1-1)*3,0)*f.getCell((1)+(2-1)*3,0)-ff.getCell((2)+(3-1)*3,0)*ff.getCell((3)+(2-1)*3,0)*f.getCell((1)+(1-1)*3,0);
	double co1=(t25+t50);

	double co0=(ff.getCell((1)+(1-1)*3,0)*ff.getCell((2)+(2-1)*3,0)*ff.getCell((3)+(3-1)*3,0)-ff.getCell((1)+(1-1)*3,0)*ff.getCell((2)+(3-1)*3,0)*ff.getCell((3)+(2-1)*3,0)-ff.getCell((1)+(2-1)*3,0)*ff.getCell((2)+(1-1)*3,0)*ff.getCell((3)+(3-1)*3,0)+ff.getCell((1)+(2-1)*3,0)*ff.getCell((2)+(3-1)*3,0)*ff.getCell((3)+(1-1)*3,0)+ff.getCell((1)+(3-1)*3,0)*ff.getCell((2)+(1-1)*3,0)*ff.getCell((3)+(2-1)*3,0)-ff.getCell((1)+(3-1)*3,0)*ff.getCell((2)+(2-1)*3,0)*ff.getCell((3)+(1-1)*3,0));

	//MyMath::MyData c = myMathHelper.zeros(1,4);
	//c.getCell(0,0) = co0;
	//c.getCell(0,1) = co1;
	//c.getCell(0,2) = co2;
	//c.matrix[0][3] = co3;
	double c[4];
	c[0] = co0;
	c[1] = co1;
	c[2] = co2;
	c[3] = co3;
	

	double r[3];
	int noOfSol;
	//r=roots(c);
	//int itayUtil::cubic(double A[4], double X[3], int* L)
	_itayUtil.cubic(c,r,&noOfSol);


	if (noOfSol ==2)
	{
		cout << "* noOfSol=2 *" << endl;
        noOfSol=1;
	}
	if (noOfSol == 0)
	{
        cout << "* noOfSol=0 *" <<endl;
        noOfSol=1;
        F=myMathHelper.zeros(3,3);
        return 0;
	}

	double t=0;
	if (noOfSol==1 && sol==1)
	{
        /*for i=1:size(r,1)
		{
    		if (isreal(r(i)))
			{
				t=r(i);
				break;
			}
		}*/
		t = r[0];
	} else
	{
        t=r[min(sol,noOfSol)];
	}

	ff=myMathHelper.addMatrices(myMathHelper.mulInScalar(f,t), myMathHelper.mulInScalar(ff,(1-t)));

	F=myMathHelper.zeros(3,3);

	//F(:,1)=ff(colon(1,3));
	myMathHelper.copyColToMatrixColInIndex(F,myMathHelper.getColumns(ff,0,2),0);
	//F(:,2)=ff(colon(4,6));
	myMathHelper.copyColToMatrixColInIndex(F,myMathHelper.getColumns(ff,3,5),1);
	//F(:,3)=ff(colon(7,9));
	myMathHelper.copyColToMatrixColInIndex(F,myMathHelper.getColumns(ff,6,8),2);

	if (sing_cons)
	{
        //[U,S,V] = svd(F);
		MyMath::MyData U1 = myMathHelper.copyMatrix(F);  
		double* w1 = new double[3+1]; 
		MyMath::MyData V1 = myMathHelper.zeros(3,3); 
		U1 = myMathHelper.padFirstRowAndCol(U1);
		V1 = myMathHelper.padFirstRowAndCol(V1);
		_itayUtil.dsvdcmp(U1.matrix, U1.numOfRows, U1.numOfCols, w1, V1.matrix);	
		//colToRemove = findSmallestValueInW(w , 4);
		//U1 = myMathHelper.removeCol(U1,colToRemove);
		// sorting U according to w
		w1[0] = -100000;
		for (int i=0; i<U1.numOfCols ; i++)
		{
			U1.getCell(0,i)=w1[i];
		}
		U1 = myMathHelper.sortColsDecreasing(U1,1);
		U1 = myMathHelper.removePadFirstRowAndLastCol(U1);
		// sorting V and w according to w
		//
		
		for (int i=0; i<V1.numOfCols ; i++)
		{
			V1.getCell(0,i)=w1[i];
		}
		V1 = myMathHelper.sortColsDecreasing(V1,1);
		for (int i=0 ; i<V1.numOfRows ; i++)
		{
			w1[i] = V1.getCell(0,i);
		}
		//
		V1 = myMathHelper.removePadFirstRowAndLastCol(V1);

        //S(3,3)=0;
		MyMath::MyData S = myMathHelper.zeros(3,3);
		S.getCell(0,0) = w1[0];
		S.getCell(1,1) = w1[1];

		S.getCell(2,2) = 0;
        
		//F=U*S*transpose(V);
		F = myMathHelper.mulMatrices(myMathHelper.mulMatrices(U1,S),myMathHelper.transposeMatrix(V1));
	}

	return noOfSol;
}

int Beem::findSmallestValueInW(double* w , int wSize)
{
	double minimum = HUGE_VAL;
	int minimumIndx = 0;
	for (int i=1 ; i<=wSize ; i++)
	{
		if (w[i]<minimum)
		{
			minimum = w[i];
			minimumIndx = i;
		}
	}
	return minimumIndx;
}

void LSH_matching(char const * argImg1Name,char const * argImg2Name,int K,int L,int k_neigh,double argDrValue, int argRansacTrValue)
{
	cout  << "img1: " << argImg1Name <<  ", img2: " << argImg2Name << ", Distance Ratio: " << argDrValue << ", Ransac TR: " << argRansacTrValue << ", K: " << K << ", L: " << L << endl;
	// Checking if processor is available...
	if (system(NULL)) puts ("Ok");
    else exit (1);
	// run SIFT of first image
	// system ("siftWin32 <img1.pgm >img1.key");
	string s1("siftWin32 < ");
	string s2(" >img1.key");
	string s3 = s1 + argImg1Name;
	string s4 = s3 + s2;
	int ss2=system (s4.c_str());
	// run SIFT of second image
	// system ("siftWin32 <img2.pgm >img2.key");
	string s1b("siftWin32 < ");
	string s2b(" >img2.key");
	string s3b = s1b + argImg2Name;
	string s4b = s3b + s2b;
	int s=system (s4b.c_str());

	MyMath::MyData disc1,disc2,cor1,cor2;
	SiftUtil::readKeypoints("img1.key" , disc1 , cor1 );
	SiftUtil::readKeypoints("img2.key" , disc2 , cor2 );

	// Do LSH matching and save results by creating p1_m,rr1,p2_m,rr2,distanceRatio into files
	myMethod(K,L,k_neigh , disc1 , cor1 , disc2 , cor2 ,argDrValue);
}