#include "StdAfx.h"
//#include "MyMath.h"


int MyMath::MyData::cells = 0;
int MyMath::MyData::nmats = 0;

MyMath::MyMath(void)
{
}

MyMath::~MyMath(void)
{
}

/*int _tmain(int argc, _TCHAR* argv[])
{
	MyMath* myMath = new MyMath();
	MyMath::MyData mat1 = (*myMath).createMat("rr1");
	cout << "rr1: " << endl;
	(*myMath).printMatrix(mat1);
	return 0;
}*/

MyMath::MyData& MyMath::zeros(int rows, int cols)
{
	MyData& matSol = *(new MyData(rows,cols));
	//MyData matSol;
	//matSol.numOfRows = rows;
	//matSol.numOfCols = cols;
	//matSol.matrix = allocateMemory(matSol.numOfRows,matSol.numOfCols);
	for (int i=0 ; i<rows ; i++)
	{
		for (int j=0 ; j<cols ; j++)
		{
			matSol.getCell(i,j) = 0;
		}
	}
	return matSol;
}

MyMath::MyData::MyData(const MyData& myData)
{
	numOfRows = myData.numOfRows;
	numOfCols = myData.numOfCols;
	allocatedNumOfRows = numOfRows;
	allocatedNumOfCols = numOfCols;
	//matrix = MyMath::allocateMemory(numOfRows,numOfCols);
	matrix = allocateMemory(numOfRows,numOfCols);
	for (int i=0 ; i<numOfRows ; i++)
	{
		for (int j=0 ; j<numOfCols ; j++)
		{
			matrix[i][j] = myData.getCell(i,j);
		}
	}
}

void MyMath::MyData::setNumOfRows(int newNumOfRows)
{
	numOfRows = newNumOfRows;
}
void MyMath::MyData::setNumOfCols(int newNumOfCols)
{
	numOfCols = newNumOfCols;
}
void MyMath::MyData::setNumOfRowsAndCols(int newNumOfRows,int newNumOfCols)
{
	numOfRows = newNumOfRows;
	numOfCols = newNumOfCols;
}

void MyMath::MyData::copyMyDataNoAlloc(const MyData& myData)
{
	numOfRows = myData.numOfRows;
	numOfCols = myData.numOfCols;
	if (numOfRows > allocatedNumOfRows || numOfCols > allocatedNumOfCols)
	{
		cout << "copyMyDataNoAlloc out of bounds";
	}
	for (int i=0 ; i<numOfRows ; i++)
	{
		for (int j=0 ; j<numOfCols ; j++)
		{
			matrix[i][j] = myData.getCell(i,j);
		}
	}
}

void MyMath::MyData::copyMyData(const MyData& myData)
{
	numOfRows = myData.numOfRows;
	numOfCols = myData.numOfCols;
	allocatedNumOfRows = numOfRows;
	allocatedNumOfCols = numOfCols;
	matrix = MyMath::allocateMemory(numOfRows,numOfCols);
	//memcpy(matrix,myData.matrix,numOfRows*numOfCols);
	//cout << "matrix : " << matrix <<endl;
	for (int i=0 ; i<numOfRows ; i++)
	{
		for (int j=0 ; j<numOfCols ; j++)
		{
			matrix[i][j] = myData.getCell(i,j);
		}
	}
	/*MyMath a;*/
	//a.printMatrix(myData);
	
}

void MyMath::MyData::setZeros()
{
	for (int i=0; i<numOfRows ; i++)
	{
		for (int j=0; j<numOfCols ; j++)
		{
			matrix[i][j] = 0;
		}
	}
}

void MyMath::MyData::operator =(const MyData& myData)
{
	//copyMyData(myData);
	destructor();
	copyMyData(myData);
}


void MyMath::MyData::assign(const MyData& myData)
{
	destructor();
	copyMyData(myData);
	/*MyMath a;
	a.printMatrix(*this);*/
	//cout << "myMatrix: " << myData.matrix << endl;
}

#ifdef undef

double& MyMath::MyData::getCell(int i, int j)
{
	if(i>=0 && i< numOfRows && j>=0 && j<numOfCols)
		return matrix[i][j];
	else{
		//cerr <<"Bug in getCell " << i << " " << j << " " << numOfRows << " " <<numOfCols << endl; 
        return matrix[0][0];
	}

}

double& MyMath::MyData::getCell(int i, int j) const
{
	if(i>=0 && i< numOfRows && j>=0 && j<numOfCols)
		return matrix[i][j];
	else{
		//cerr <<"Bug in getCell " << i << " " << j << " " << numOfRows << " " <<numOfCols << endl; 
        return matrix[0][0];
	}

}

#endif

MyMath::MyData::MyData(int rows, int cols)
{
	numOfRows = rows;
    numOfCols = cols;
	allocatedNumOfRows = numOfRows;
	allocatedNumOfCols = numOfCols;
	matrix = MyMath::allocateMemory(numOfRows,numOfCols);
	nmats++;
	cells += numOfRows * numOfCols;
}

MyMath::MyData::~MyData()
{
	destructor();
}

void MyMath::MyData::destructor()
{
	
	for (int i=0; i<numOfRows ; i++)
	{
		delete [] matrix[i];
	}
	if (numOfRows>0 && numOfCols>0){
		delete [] matrix;
	}
	matrix = 0;
	numOfRows = 0;
	numOfCols = 0;
	allocatedNumOfRows = 0;
	allocatedNumOfCols = 0;
	nmats--;
	cells -= numOfRows * numOfCols;
}

MyMath::MyData& MyMath::transposeMatrix(const MyMath::MyData& mat)
{
	MyData& matSol = *(new MyData(mat.numOfCols,mat.numOfRows)); 
    
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		for (int j=0 ; j<matSol.numOfCols ; j++)
		{
			matSol.getCell(i,j) = mat.getCell(j,i);
		}
	}
	return matSol;
}

MyMath::MyData& MyMath::concatMatricesMoreRows(const MyMath::MyData& mat1, const MyMath::MyData& mat2)
{
	MyData& matSol = *(new MyData(mat1.numOfRows + mat2.numOfRows,mat1.numOfCols));
	
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		for (int j=0 ; j<matSol.numOfCols ; j++)
		{
			if (i<mat1.numOfRows)
			{
				matSol.getCell(i,j) = mat1.getCell(i,j);
			} else
			{
				matSol.getCell(i,j) = mat2.getCell(i-mat1.numOfRows,j);
			}
		}
	}
	return matSol;
}

MyMath::MyData& MyMath::concatMatricesMoreColumns(const MyMath::MyData& mat1, const MyMath::MyData& mat2)
{
	MyData& matSol = *(new MyData(mat1.numOfRows,mat1.numOfCols + mat2.numOfCols));
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		for (int j=0 ; j<matSol.numOfCols ; j++)
		{
			if (j<mat1.numOfCols)
			{
				matSol.getCell(i,j) = mat1.getCell(i,j);
			} else
			{
				matSol.getCell(i,j) = mat2.getCell(i,j-mat1.numOfCols);
			}
		}
	}
	return matSol;
}

MyMath::MyData& MyMath::getColumn(const MyMath::MyData& mat, int colNumber)
{
	MyData& matSol = *(new MyData(mat.numOfRows,1));
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		matSol.getCell(i,0) = mat.getCell(i,colNumber);
	}
	return matSol;
}

double* MyMath::getColumnAsArray(const MyData& mat,int colNumber)
{
	double* arraySol = new double[mat.numOfRows];
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		arraySol[i] = mat.getCell(i,colNumber);
	}
	return arraySol;
}

MyMath::MyData& MyMath::getRow(const MyMath::MyData& mat, int rowNumber)
{
	MyData& matSol = *(new MyData(1,mat.numOfCols));
	for (int i=0 ; i<matSol.numOfCols ; i++)
	{
		matSol.getCell(0,i) = mat.getCell(rowNumber,i);
	}
	return matSol;
}

MyMath::MyData& MyMath::getRows(const MyMath::MyData& mat, MyMath::MyData& rowNumbers)
{
	int transposeFlag=0;
	if (rowNumbers.numOfRows == 1)
	{
		rowNumbers = transposeMatrix(rowNumbers);
		transposeFlag=1;
	}

	MyData& matSol = *(new MyData(rowNumbers.numOfRows,mat.numOfCols));
	for (int j=0 ; j<rowNumbers.numOfRows ; j++)
	{
		for (int i=0 ; i<matSol.numOfCols ; i++)
		{
			matSol.getCell(j,i) = mat.getCell((int)rowNumbers.getCell(j,0),i);
		}
	}
	if (transposeFlag==1)
	{
		rowNumbers = transposeMatrix(rowNumbers);
	}
	return matSol;
}

MyMath::MyData& MyMath::getRows(MyMath::MyData mat, int 
rowStartOfBuffer,int rowEndOfBuffer)
{
	MyData& matSol = *(new MyData(rowEndOfBuffer - rowStartOfBuffer + 1,mat.numOfCols));
	
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		for (int j=0 ; j<matSol.numOfCols ; j++)
		{
			matSol.getCell(i,j) = mat.getCell(rowStartOfBuffer + i,j);
		}
	}
	return matSol;
}

void MyMath::copyColToMatrixColInIndex(MyMath::MyData mat,MyMath::MyData col , int index)
{
	int transposeFlag=0;
	if (col.numOfCols>1)
	{
		col = transposeMatrix(col);
		transposeFlag=1;
	}
	if (mat.numOfRows!=col.numOfRows)
	{
		cout << "matrix dimensions don't agree!!" << endl;
		exit(1);
	}

	for (int i=0 ; i<col.numOfRows ; i++)
	{
		mat.getCell(i,index) = col.getCell(i,0);
	}

	if (transposeFlag==1)
	{
		col = transposeMatrix(col);
	}
}

MyMath::MyData& MyMath::pointMatrixMul(MyMath::MyData& mat1,MyMath::MyData& mat2)
{
	if ((mat1.numOfCols!=mat2.numOfCols) || (mat1.numOfRows!=mat2.numOfRows))
	{
		cout << "matrix dimensions don't agree!!" << endl;
		exit(1);
	}
	MyData& matSol = *(new MyData(mat1.numOfRows,mat1.numOfCols));
	//MyData matSol;
	//matSol.numOfRows = mat1.numOfRows;
	//matSol.numOfCols = mat1.numOfCols;
	//matSol.matrix = allocateMemory(matSol.numOfRows,matSol.numOfCols);
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		for (int j=0 ; j<matSol.numOfCols ; j++)
		{
			matSol.getCell(i,j) = mat1.getCell(i,j) * mat2.getCell(i,j);
		}
	}
	return matSol;
}

MyMath::MyData& MyMath::findBiggerThenScalar(MyMath::MyData& mat, double scalar)
{
	MyData& matSol = zeros(mat.numOfRows,mat.numOfCols);
	
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		for (int j=0 ; j<matSol.numOfCols ; j++)
		{
			if (mat.getCell(i,j) > scalar)
			{
				matSol.getCell(i,j) = 1;
			}
			
		}
	}
	return matSol;
}

MyMath::MyData& MyMath::findSmallerOrEqualThenScalar(MyMath::MyData& mat, double scalar)
{
	MyData& matSol = zeros(mat.numOfRows,mat.numOfCols);
	
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		for (int j=0 ; j<matSol.numOfCols ; j++)
		{
			if (mat.getCell(i,j) <= scalar)
			{
				matSol.getCell(i,j) = 1;
			}
			
		}
	}
	return matSol;
}

MyMath::MyData& MyMath::findSmallerThenScalar(MyMath::MyData& mat, double scalar)
{
	MyData& matSol = zeros(mat.numOfRows,mat.numOfCols);
	
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		for (int j=0 ; j<matSol.numOfCols ; j++)
		{
			if (mat.getCell(i,j) < scalar)
			{
				matSol.getCell(i,j) = 1;
			}
			
		}
	}
	return matSol;
}

MyMath::MyData& MyMath::findEqualsToScalarIndexes(MyMath::MyData mat, double scalar)
{
	//MyData indexes;
	int *rows = new int[mat.numOfRows * mat.numOfCols];
	int *cols = new int[mat.numOfRows * mat.numOfCols];
	int howManyFound = 0;
	for (int i=0 ; i<mat.numOfCols ; i++)
	{
		for (int j=0 ; j<mat.numOfRows ; j++)
		{
			if (mat.getCell(j,i) == scalar)
			{
				rows[howManyFound] = j;
				cols[howManyFound] = i;
				howManyFound++;
			}
		}
	}
	//indexes.numOfRows = howManyFound;
	//indexes.numOfCols=1;
	//indexes.matrix = allocateMemory(indexes.numOfRows,indexes.numOfCols);
	MyData& indexes = *(new MyData(howManyFound,1));
	//MyData& matSol = *(new MyData(matFrom.numOfRows,matFrom.numOfCols));
	for (int i=0 ; i<howManyFound ; i++)
	{
		indexes.getCell(i,0) = rows[i] + cols[i]*mat.numOfRows;
	}
	
	return indexes;
}

MyMath::MyData& MyMath::copyMatrix(const MyMath::MyData& matFrom)
{
	MyData& matSol = *(new MyData(matFrom.numOfRows,matFrom.numOfCols));
	//MyData matSol;
	//matSol.numOfRows = matFrom.numOfRows;
	//matSol.numOfCols = matFrom.numOfCols;
	//matSol.matrix = allocateMemory(matSol.numOfRows,matSol.numOfCols);
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		for (int j=0 ; j<matSol.numOfCols ; j++)
		{
			matSol.getCell(i,j) = matFrom.getCell(i,j);
		}
	}
	return matSol;
}

MyMath::MyData& MyMath::padFirstRowAndCol(MyMath::MyData& mat)
{
	MyData& matSol = zeros(mat.numOfRows+1,mat.numOfCols+1);
	for (int i=1 ; i<matSol.numOfRows ; i++)
	{
		for (int j=1 ; j<matSol.numOfCols ; j++)
		{
			matSol.getCell(i,j) = mat.getCell(i-1,j-1);
		}
	}
	return matSol;
}

MyMath::MyData& MyMath::removePadFirstRowAndLastCol(MyMath::MyData& mat)
{
	MyData& matSol = zeros(mat.numOfRows-1,mat.numOfCols-1);
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		for (int j=0 ; j<matSol.numOfCols ; j++)
		{
			matSol.getCell(i,j) = mat.getCell(i+1,j);
		}
	}
	return matSol;
}

/*colNumber between 1 and numberOfCols */
MyMath::MyData MyMath::removeCol(MyMath::MyData mat , int colNumber)
{
	MyData matSol;
	matSol = zeros(mat.numOfRows,mat.numOfCols-1);
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		for (int j=0 ; j<colNumber ; j++)
		{
			matSol.getCell(i,j) = mat.getCell(i,j);
		}
	}
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		for (int j=colNumber+1 ; j<mat.numOfCols ; j++)
		{
			matSol.getCell(i,j-1) = mat.getCell(i,j);
		}
	}

	return matSol;
}

MyMath::MyData MyMath::removePadFirstRowAndCol(MyMath::MyData mat)
{
	MyData matSol;
	matSol = zeros(mat.numOfRows-1,mat.numOfCols-1);
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		for (int j=0 ; j<matSol.numOfCols ; j++)
		{
			matSol.getCell(i,j) = mat.getCell(i+1,j+1);
		}
	}
	return matSol;
}

MyMath::MyData& MyMath::findSmallerOrEqualsToScalarIndexes(MyMath::MyData& mat, double scalar)
{
	int *rows = new int[mat.numOfRows * mat.numOfCols];
	int *cols = new int[mat.numOfRows * mat.numOfCols];
	int howManyFound = 0;
	for (int i=0 ; i<mat.numOfCols ; i++)
	{
		for (int j=0 ; j<mat.numOfRows ; j++)
		{
			if (mat.getCell(j,i) <= scalar)
			{
				rows[howManyFound] = j;
				cols[howManyFound] = i;
				howManyFound++;
			}
		}
	}
	MyData& indexes = *(new MyData(howManyFound,1));
	for (int i=0 ; i<howManyFound ; i++)
	{
		indexes.getCell(i,0) = rows[i] + cols[i]*mat.numOfRows;
	}
	
	return indexes;
}

double MyMath::matrixStd(MyMath::MyData& A)
{
	double variance = 0;
	double avg = 0;

	if ((A.numOfCols>1) && (A.numOfRows>1))
	{
		cerr << "method can't handle matrices, only vectors." << endl;
		exit(1);
	}
	int transposeFlag=0;
	if (A.numOfCols>1)
	{
		A = transposeMatrix(A);
		transposeFlag=1;
	}
	for (int i=0 ; i<A.numOfRows ; i++)
	{
		avg += A.getCell(i,0);
	}
	avg /= A.numOfRows;
	
	for (int i=0 ; i<A.numOfRows ; i++)
	{
		variance += SQR(A.getCell(i,0)-avg);
	}
	variance /= A.numOfRows;
	if (transposeFlag==1)
	{
		A = transposeMatrix(A);
	}
	return sqrt(variance);
}

MyMath::MyData& MyMath::sumMatrix(MyMath::MyData& mat)
{
	//MyData matSol;
	if (mat.numOfRows>1)
	{
		MyData& matSol = zeros(1,mat.numOfCols);
		for (int i=0; i < mat.numOfRows ; i++)
		{
			for (int j=0; j < mat.numOfCols ; j++)
			{
				matSol.getCell(0,j) += mat.getCell(i,j);
			}
		}
		return matSol;
	} else
	{
		MyData& matSol = zeros(1,1);
		for (int i=0 ; i<mat.numOfCols ; i++)
		{
			matSol.getCell(0,0) += mat.getCell(0,i);
		}
		return matSol;
	}
	//return matSol;
}

MyMath::MyData& MyMath::meanMatrix(MyMath::MyData& mat)
{
	MyData matSol;
	matSol = sumMatrix(mat);
	for (int i=0 ; i<matSol.numOfCols ; i++)
	{
		matSol.getCell(0,i) = matSol.getCell(0,i) / mat.numOfRows;
	}
	return transposeMatrix(matSol); //todo check why transpose?
}

double MyMath::matrixNorm(MyMath::MyData& F)
{
	double powSum = 0;
	for (int i=0 ; i<F.numOfRows ; i++)
	{
		for (int j=0 ; j<F.numOfCols ; j++)
		{
			powSum += SQR(F.getCell(i,j));
		}
	}
	return sqrt(powSum);
}

MyMath::MyData& MyMath::roundMatrixValues(MyMath::MyData& mat)
{
	MyData& matSol = *(new MyData(mat.numOfRows,mat.numOfCols));
	//MyData matSol;
	//matSol.numOfRows = mat.numOfRows;
	//matSol.numOfCols = mat.numOfCols;
	//matSol.matrix = allocateMemory(matSol.numOfRows,matSol.numOfCols);
	
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		for (int j=0 ; j<matSol.numOfCols ; j++)
		{
			matSol.getCell(i,j) = floor(mat.getCell(i,j) + 0.5);
		}
	}
	return matSol;
}

double MyMath::findMaxInMatrix(MyMath::MyData& mat)
{
	double maxValue = -HUGE_VAL;
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		for (int j=0 ; j<mat.numOfCols ; j++)
		{
			if (mat.getCell(i,j)>maxValue)
			{
				maxValue = mat.getCell(i,j);
			}
		}
	}
	return maxValue;
}

MyMath::Indices MyMath::findInMatrix(MyMath::MyData mat)
{
	Indices indices;
	int *rows = new int[mat.numOfRows * mat.numOfCols];
	int *cols = new int[mat.numOfRows * mat.numOfCols];
	int howManyFound = 0;
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		for (int j=0 ; j<mat.numOfCols ; j++)
		{
			if (mat.getCell(i,j) != 0)
			{
				rows[howManyFound] = i;
				cols[howManyFound] = j;
				howManyFound++;
			}
		}
	}
	indices.size = howManyFound;
	indices.row = rows;
	indices.col = cols;
	return indices;
}

MyMath::MyData MyMath::createSubMatrixVector(MyMath::MyData mat, MyMath::Indices indices)
{
	MyData& matSol = *(new MyData(indices.size,1));
	//MyData matSol;
	//matSol.numOfRows = indices.size;
	//matSol.numOfCols = 1;
	//matSol.matrix = allocateMemory(matSol.numOfRows, matSol.numOfCols);
	for (int i=0 ; i<indices.size ; i++)
	{
		matSol.getCell(i,0) = mat.getCell(indices.row[i],indices.col[i]);
	}
	return matSol;
}

MyMath::MyData& MyMath::create3ElementsRowVector(double a, double b, double c)
{
	MyData& matSol = *(new MyData(1,3));
	//MyData matSol;
	//matSol.numOfRows = 1;
	//matSol.numOfCols = 3;
	//matSol.matrix = allocateMemory(matSol.numOfRows, matSol.numOfCols);
	
	matSol.getCell(0,0) = a;
	matSol.getCell(0,1) = b;
	matSol.getCell(0,2) = c;
	
	return matSol;
}

//MyMath::Indexes MyMath::findIndexesInMatrix(MyMath::MyData mat)
MyMath::MyData& MyMath::findIndexesInMatrix(MyMath::MyData& mat)
{
	//MyData indexes;
	int *rows = new int[mat.numOfRows * mat.numOfCols];
	int *cols = new int[mat.numOfRows * mat.numOfCols];
	int howManyFound = 0;
	for (int i=0 ; i<mat.numOfCols ; i++)
	{
		for (int j=0 ; j<mat.numOfRows ; j++)
		{
			if (mat.getCell(j,i) != 0)
			{
				rows[howManyFound] = j;
				cols[howManyFound] = i;
				howManyFound++;
			}
		}
	}
	MyData& indexes = *(new MyData(howManyFound,1));
	//indexes.numOfRows = howManyFound;
	//indexes.numOfCols=1;
	//indexes.matrix = allocateMemory(indexes.numOfRows,indexes.numOfCols);
	for (int i=0 ; i<howManyFound ; i++)
	{
		indexes.getCell(i,0) = rows[i] + cols[i]*mat.numOfRows;
	}
	
	return indexes;
}

//MyMath::MyData MyMath::createSubMatrixVector(MyMath::MyData mat, MyMath::Indexes indexes)
MyMath::MyData& MyMath::createSubMatrixVector(MyMath::MyData& mat, const MyMath::MyData& indexes)
{
	int row = 0;
	int col = 0;
	if (indexes.numOfRows == 1)
	{
		MyData& matSol = *(new MyData(indexes.numOfCols,1));
		for (int i=0 ; i<indexes.numOfCols ; i++)
		{
			col = (int)floor((double)indexes.getCell(0,i)/mat.numOfRows);
			row = (int)(indexes.getCell(0,i) - (col*mat.numOfRows));
			matSol.getCell(i,0) = mat.getCell(row,col);
		}
		return matSol;
	}else{	
		MyData& matSol = *(new MyData(indexes.numOfRows,1));
		for (int i=0 ; i<indexes.numOfRows ; i++)
		{
			col = (int)floor((double)indexes.getCell(i,0)/mat.numOfRows);
			row = (int)(indexes.getCell(i,0) - (col*mat.numOfRows));
			matSol.getCell(i,0) = mat.getCell(row,col);
		}
		return matSol;
	}
}

MyMath::MyData MyMath::createSubMatrixVector(MyMath::MyData mat, int startOfBuffer, int endOfBuffer)
{
	MyData& matSol = *(new MyData(endOfBuffer - startOfBuffer + 1,1));
	//MyData matSol;
	//matSol.numOfRows = endOfBuffer - startOfBuffer + 1;
	//matSol.numOfCols = 1;
	//matSol.matrix = allocateMemory(matSol.numOfRows, matSol.numOfCols);
	int row = startOfBuffer;
	int col = 0;
	int index =0;
	for (int i=startOfBuffer ; i<(endOfBuffer+1) ; i++)
	{
		if (row == mat.numOfRows)
		{
			row=0;
			col++;
		}
		matSol.getCell(index++,0) = mat.getCell(row,col);
		row++;
	}
	return matSol;
}

MyMath::MyData& MyMath::getMatrix(MyMath::MyData& mat,MyMath::MyData& rowsIndexes,int colStartOfBuffer,int colEndOfBuffer)
{
	MyData allRows = getRows(mat,rowsIndexes);
	MyData& matSol = getColumns(allRows,colStartOfBuffer,colEndOfBuffer);
	return matSol;
}

MyMath::MyData& MyMath::getColumns(MyMath::MyData& mat,int colStartOfBuffer,int colEndOfBuffer)
{
	MyData& matSol = *(new MyData(mat.numOfRows,colEndOfBuffer - colStartOfBuffer + 1));
	//MyData matSol;
	//matSol.numOfRows = mat.numOfRows;
	//matSol.numOfCols = colEndOfBuffer - colStartOfBuffer + 1;
	//matSol.matrix = allocateMemory(matSol.numOfRows,matSol.numOfCols);
	
	for (int i=0 ; i<matSol.numOfRows ; i++)
	{
		for (int j=0 ; j<matSol.numOfCols ; j++)
		{
			matSol.getCell(i,j) = mat.getCell(i,colStartOfBuffer + j);
		}
	}
	return matSol;

}

MyMath::MyData& MyMath::sortRows(MyMath::MyData& mat,int columnNumber)
{
	MyData& indexes = *(new MyData(mat.numOfRows , 1));
	//MyData indexes;
	//indexes.numOfCols = 1;
	////indexes.numOfRows = mat.numOfCols;
	//indexes.numOfRows = mat.numOfRows;
	//indexes.matrix = allocateMemory(indexes.numOfRows,indexes.numOfCols);
	
	MyData sortingColumn = getColumn(mat,columnNumber-1);
	MyData sortedColumn = matrixSort(sortingColumn);

	double number=0;
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		number = sortedColumn.getCell(i,0);
		for (int j=0 ; j<mat.numOfRows ; j++)
		{
			if (sortingColumn.getCell(j,0) == number)
			{
				indexes.getCell(i++,0) = j;
			}
		}
		i--;
	}
	
	MyData& matSol = getRows(mat,indexes);
	return matSol;
}

MyMath::MyData& MyMath::sortRowsDecreasing(MyMath::MyData& mat,int columnNumber)
{
	MyData& indexes = *(new MyData(mat.numOfCols , 1));
	/*MyData indexes;
	indexes.numOfCols = 1;
	indexes.numOfRows = mat.numOfCols;
	indexes.matrix = allocateMemory(indexes.numOfRows,indexes.numOfCols);*/
	
	MyData sortingColumn = getColumn(mat,columnNumber-1);
	MyData sortedColumn = matrixSort(sortingColumn);

	double number=0;
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		number = sortedColumn.getCell(mat.numOfRows-1 - i,0);
		for (int j=0 ; j<mat.numOfRows ; j++)
		{
			if (sortingColumn.getCell(j,0) == number)
			{
				indexes.getCell(i++,0) = j;
			}
		}
		i--;
	}
	
	MyData& matSol = getRows(mat,indexes);
	return matSol;
}

MyMath::MyData& MyMath::sortColsDecreasing(MyMath::MyData& mat,int rowNumber)
{
	MyData& matSol = transposeMatrix(mat);
	matSol = sortRowsDecreasing(matSol,rowNumber);
	matSol = transposeMatrix(matSol);
	return matSol;
}

//void MyMath::setScalarValueInIndexes(MyMath::MyData mat, MyMath::Indexes indexes, double value)
void MyMath::setScalarValueInIndexes(MyMath::MyData& mat, MyMath::MyData& indexes, double value)
{
	int row=0;
	int col=0;
	if (indexes.numOfRows==1)
	{
		for (int i=0 ; i<indexes.numOfCols ; i++)
		{
			col = (int)(indexes.getCell(0,i)/mat.numOfRows);
			row = (int)(indexes.getCell(0,i) - col*mat.numOfRows);
			mat.getCell(row,col) = value;
		}
	} else{
		for (int i=0 ; i<indexes.numOfRows ; i++)
		{
			col = (int)(indexes.getCell(i,0)/mat.numOfRows);
			row = (int)(indexes.getCell(i,0) - col*mat.numOfRows);
			mat.getCell(row,col) = value;
		}
	}
}

MyMath::MyData& MyMath::createNewMatrixVectorAccordingToIndexes(MyMath::MyData& mat, MyMath::MyData& indexes)
{
	int transposeFlag=0;
	if (indexes.numOfRows==1)
	{
		indexes = transposeMatrix(indexes);
		transposeFlag=1;
	}
	MyData& matSol = *(new MyData(indexes.numOfRows,1));
	//MyData matSol;
	//matSol.numOfRows = indexes.numOfRows;
	//matSol.numOfCols = 1;
	//matSol.matrix = allocateMemory(matSol.numOfRows,matSol.numOfCols);

	int row=0;
	int col=0;
	for (int i=0 ; i<indexes.numOfRows ; i++)
	{
		col = (int)(indexes.getCell(i,0)/mat.numOfRows);
		row = (int)(indexes.getCell(i,0) - col*mat.numOfRows);
		matSol.getCell(i,0) = mat.getCell(row,col);
	}
	if (transposeFlag==1)
	{
		indexes = transposeMatrix(indexes);
	}
	return matSol;
}

void MyMath::printMatToFile(MyMath::MyData& mat, char const *fileName)
{
	ofstream file(fileName);
	file << mat.numOfRows << endl;
	file << mat.numOfCols << endl;
	for (int j=0 ; j<mat.numOfCols ; j++)
	{
		for (int i=0 ; i<mat.numOfRows ; i++)
		{
			file << mat.getCell(i,j) << endl;
		}
	}
}

void MyMath::printMatToFileStandard(MyMath::MyData& mat, char 
const *fileName)
{
	ofstream file(fileName);
	//file << mat.numOfRows << endl;
	//file << mat.numOfCols << endl;
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		for (int j=0 ; j<mat.numOfCols ; j++)
		{
			file << mat.getCell(i,j) << " ";
		}
		file << endl;
	}
}

MyMath::MyData& MyMath::createMat(char const *fileName)
{
	ifstream file(fileName);
	if (! file){
		cerr << "Could not open file: " << fileName;
		exit(1);
	}
	//MyData mat;
	//file >> mat.numOfRows;
	//file >> mat.numOfCols;
	int numOfRows = 0;
	int numOfCols = 0;
	file >> numOfRows;
	file >> numOfCols;
	//mat.matrix = allocateMemory(mat.numOfRows, mat.numOfCols);
	MyData& mat = *(new MyData(numOfRows,numOfCols));
	for (int j=0 ; j<mat.numOfCols ; j++)
	{
		for (int i=0 ; i<mat.numOfRows ; i++)
		{
			file >> mat.getCell(i,j);
		}
	}
	return mat;
}

 double **MyMath::allocateMemory(int numOfRows, int numOfCols)
{
	double **mat=0;
	mat = new double*[numOfRows];
	for (int i=0 ; i<numOfRows ; i++)
	{
		mat[i] = new double[numOfCols];
	}
	return mat;
}


/*MyMath::MyData MyMath::mulMatrices(MyData& mat1, MyData& mat2)
{
	if (mat1.numOfCols != mat2.numOfRows)
	{
		cerr << "matrix dimentions must agree!!" << endl;
	}
	MyData matSol;
	matSol.numOfRows = mat1.numOfRows;
	matSol.numOfCols = mat2.numOfCols;
	matSol.matrix = new double*[matSol.numOfRows];
	double tmpNum=0;
	for (int i=0 ; i<mat1.numOfRows ; i++)
	{
		matSol.matrix[i] = new double[matSol.numOfCols];
		for (int j=0 ; j<mat2.numOfCols ; j++)
		{
			tmpNum = 0;
			for (int k=0 ; k<mat2.numOfRows ; k++)
			{
				//tmpNum = tmpNum + mat1.getCell(i,k) * mat2.getCell(k,j);
				tmpNum += mat1.getCell(i,k) * mat2.getCell(k,j);
			}
			matSol.getCell(i,j) = tmpNum;
		}
	}
	return matSol;
}*/

MyMath::MyData& MyMath::mulMatrices(MyData& mat1, MyData& mat2)
{
	if (mat1.numOfCols != mat2.numOfRows)
	{
		cerr << "matrix dimentions must agree!!" << endl;
	}
	MyData& matSol = *(new MyData(mat1.numOfRows , mat2.numOfCols));
	
	double tmpNum=0;
	for (int i=0 ; i<mat1.numOfRows ; i++)
	{
		for (int j=0 ; j<mat2.numOfCols ; j++)
		{
			tmpNum = 0;
			for (int k=0 ; k<mat2.numOfRows ; k++)
			{
				tmpNum += mat1.getCell(i,k) * mat2.getCell(k,j);
			}
			matSol.getCell(i,j) = tmpNum;
		}
	}
	return matSol;
}

void MyMath::mulFWith3elements2Results(double* result , MyData& F , double e1 , double e2 , double e3 , bool transposeFflag)
{
	//double result[] = {0,0};
	if (!transposeFflag)
	{
		for (int i=0; i<F.numOfRows ; i++)
		{
			result[i] = F.getCell(i,0) * e1 + F.getCell(i,1) * e2 + F.getCell(i,2) * e3;
		}
	} else 
	{
		for (int i=0; i<F.numOfCols ; i++)
		{
			result[i] = F.getCell(0,i) * e1 + F.getCell(1,i) * e2 + F.getCell(2,i) * e3;
		}
	}
	//return result;
}


/*MyMath::MyData MyMath::mulMatrices(MyData mat1, MyData mat2)
{
	if (mat1.numOfCols != mat2.numOfRows)
	{
		cerr << "matrix dimentions must agree!!" << endl;
	}
	MyData matSol;
	matSol.numOfRows = mat1.numOfRows;
	matSol.numOfCols = mat2.numOfCols;
	matSol.matrix = new double*[matSol.numOfCols];
	double tmpNum=0;
	for (int i=0 ; i<mat2.numOfCols ; i++)
	{
		matSol.matrix[i] = new double[matSol.numOfRows];
		for (int j=0 ; j<mat1.numOfRows ; j++)
		{
			tmpNum = 0;
			for (int k=0 ; k<mat1.numOfCols ; k++)
			{
				tmpNum = tmpNum + mat1.matrix[j][k] * mat2.matrix[k][i];
			}
			matSol.getCell(i,j) = tmpNum;
		}
	}
	return matSol;
}*/

MyMath::MyData& MyMath::divideInScalar(MyMath::MyData& mat, double divider)
{
	MyData& matSol = *(new MyData(mat.numOfRows,mat.numOfCols));
	//MyData matSol;
	//matSol.numOfRows = mat.numOfRows;
	//matSol.numOfCols = mat.numOfCols;
	//matSol.matrix = allocateMemory(matSol.numOfRows, matSol.numOfCols);
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		for (int j=0 ; j<mat.numOfCols ; j++)
		{
			matSol.getCell(i,j) = mat.getCell(i,j) / divider;
		}
	}
	return matSol;
}

void MyMath::divideInScalar2(MyMath::MyData& mat, double divider)
{
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		for (int j=0 ; j<mat.numOfCols ; j++)
		{
			mat.getCell(i,j) /= divider;
		}
	}
}

MyMath::MyData& MyMath::mulInScalar(MyMath::MyData& mat, double multiplier)
{
	MyData& matSol = *(new MyData(mat.numOfRows,mat.numOfCols));
	//MyData matSol;
	//matSol.numOfRows = mat.numOfRows;
	//matSol.numOfCols = mat.numOfCols;
	//matSol.matrix = allocateMemory(matSol.numOfRows, matSol.numOfCols);
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		for (int j=0 ; j<mat.numOfCols ; j++)
		{
			matSol.getCell(i,j) = mat.getCell(i,j) * multiplier;
		}
	}
	return matSol;
}

void MyMath::mulInScalar2(MyMath::MyData& mat, double multiplier)
{
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		for (int j=0 ; j<mat.numOfCols ; j++)
		{
			mat.getCell(i,j) *= multiplier;
		}
	}
}

void MyMath::doAcos(MyMath::MyData& mat)
{
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		for (int j=0 ; j<mat.numOfCols ; j++)
		{
			mat.getCell(i,j) = acos(mat.getCell(i,j));
		}
	}
}

MyMath::MyData& MyMath::absMatrix(MyMath::MyData mat)
{
	MyData& matSol = *(new MyData(mat.numOfRows,mat.numOfCols));
	//MyData matSol;
	//matSol.numOfRows = mat.numOfRows;
	//matSol.numOfCols = mat.numOfCols;
	//matSol.matrix = allocateMemory(matSol.numOfRows, matSol.numOfCols);
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		for (int j=0 ; j<mat.numOfCols ; j++)
		{
			matSol.getCell(i,j) = abs(mat.getCell(i,j)) ;
		}
	}
	return matSol;
}

void MyMath::absMatrix2(MyMath::MyData& mat)
{
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		for (int j=0 ; j<mat.numOfCols ; j++)
		{
			mat.getCell(i,j) = abs(mat.getCell(i,j)) ;
		}
	}
}

void MyMath::MyData::addScalar(int scalar)
{
	for (int i=0 ; i<numOfRows ; i++)
	{
		for (int j=0 ; j<numOfCols ; j++)
		{
			matrix[i][j] += scalar;
		}
	}

}

MyMath::MyData& MyMath::addScalar(MyMath::MyData& mat, double addition)
{
	MyData& matSol = *(new MyData(mat.numOfRows,mat.numOfCols));
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		for (int j=0 ; j<mat.numOfCols ; j++)
		{
			matSol.getCell(i,j) = mat.getCell(i,j) + addition;
		}
	}
	return matSol;
}

void MyMath::addScalar2(MyMath::MyData& mat, double addition)
{
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		for (int j=0 ; j<mat.numOfCols ; j++)
		{
			mat.getCell(i,j) += addition;
		}
	}
}

MyMath::MyData& MyMath::matrixSort(MyMath::MyData mat)
{
	MyData& matSol = transposeMatrix(mat);
	for (int i=0 ; i< matSol.numOfRows ; i++)
	{
		sort((matSol.matrix)[i] , (matSol.matrix)[i] + matSol.numOfCols );
	}
	matSol = transposeMatrix(matSol);
	return matSol;
}

MyMath::MyData& MyMath::sortOneRow(MyMath::MyData& mat)
{
	MyData& matSol = copyMatrix(mat);
	sort((matSol.matrix)[0] , (matSol.matrix)[0] + matSol.numOfCols );
	return matSol;
}

int MyMath::findIndxInRow(MyMath::MyData& mat,double val)
{
	for (int i=0 ; i<mat.numOfCols ; i++)
	{
		if (mat.getCell(0,i) == val)
		{
			return i;
		}
	}
	return -1;
}

MyMath::MyData MyMath::addMatrices(MyMath::MyData mat1, MyMath::MyData mat2)
{
	if (mat1.numOfCols!=mat2.numOfCols || mat1.numOfRows!=mat2.numOfRows)
	{
		cerr << "matrix dimentions must agree!!" << endl;
	}
	MyData& matSol = *(new MyData(mat1.numOfRows,mat1.numOfCols));
	//MyData matSol;
	//matSol.numOfRows = mat1.numOfRows;
	//matSol.numOfCols = mat1.numOfCols;
	//matSol.matrix = allocateMemory(matSol.numOfRows, matSol.numOfCols);
	for (int i=0 ; i<matSol.numOfCols ; i++)
	{
		for (int j=0 ; j<matSol.numOfRows ; j++)
		{
			matSol.getCell(i,j) = mat1.getCell(i,j) + mat2.getCell(i,j);
		}
	}
	return matSol;
}

void MyMath::printMatrix(const MyData& mat)
{
	for (int i=0 ; i<mat.numOfRows ; i++)
	{
		for (int j=0 ; j<mat.numOfCols ; j++)
		{
			cout << mat.getCell(i,j) << " ";
		}
		cout << endl;
	}
}


