
#pragma once

#include <stdio.h>
//#include <tchar.h>



// TODO: reference additional headers your program requires here
#include <complex>
#include <iostream>
#include <fstream>
#include <string>
#include <math.h>
#include <stdlib.h>
#include <algorithm>

#define SQR(a)   ((a)*(a))


class MyMath
{
public:
	class MyData
	{
	public:
		static int nmats, cells;
		int allocatedNumOfRows;
		int allocatedNumOfCols;
		int numOfRows;
		int numOfCols;
		double **matrix;
		double& getCell(int i, int j) { return matrix[i][j];};
		double& getCell(int i, int j) const {return matrix[i][j];};

		void addScalar(int scalar);
		void setZeros();

        ////????MyData(int cols,int rows);
		MyData(int rows,int cols);
		MyData(void){ matrix = 0;
					  numOfRows = 0;
					  numOfCols = 0;
					  allocatedNumOfRows = 0;
					  allocatedNumOfCols = 0;};
		~MyData(void);
		void destructor();
		MyData(const MyData& myData);
		void operator =(const MyData& myData);
		void assign(const MyData& myData);
		void copyMyData(const MyData& myData);
		void copyMyDataNoAlloc(const MyData& myData);

		void setNumOfRowsAndCols(int newNumOfRows,int newNumOfCols);
		void setNumOfRows(int newNumOfRows);
		void setNumOfCols(int newNumOfCols);
	};


	struct Indices
	{
		int *row;
		int *col;
		int size;
	}indices;

	/*struct Indexes
	{
		int *index;
		int size;
	}indexes;*/

	MyData& mulMatrices(MyData& mat1, MyData& mat2);
	MyData& mulInScalar(MyData& mat, double multiplier);
	void mulInScalar2(MyData& mat, double multiplier);
	void doAcos(MyData& mat);
	MyData& sortOneRow(MyData& mat);
	int findIndxInRow(MyData& mat,double val);
	MyData& divideInScalar(MyData& mat, double divider);
	void divideInScalar2(MyData& mat, double divider);
	MyData& addScalar(MyData& mat, double addition);
	void addScalar2(MyData& mat, double addition);
	MyData addMatrices(MyData mat1, MyData mat2);
	MyData& zeros(int rows, int cols);
	MyData& absMatrix(MyData mat);
	void absMatrix2(MyData& mat);

	MyData& transposeMatrix(const MyData& mat);

	MyData& concatMatricesMoreColumns(const MyData& mat1, const MyData& mat2);
	MyData& concatMatricesMoreRows(const MyData& mat1, const MyData& mat2);

	// replacing matlab (:,colNumber)
	MyData& getColumn(const MyData& mat, int colNumber);
	double* getColumnAsArray(const MyData& mat,int colNumber);

	// replacing matlab (rowNumber,:)
	MyData& getRow(const MyData& mat, int rowNumber);

	MyData& getRows(const MyData& mat, MyData& rowNumbers);
	MyData& getRows(MyData mat, int rowStartOfBuffer,int 
rowEndOfBuffer);

	// finds all the indices where the matrix is not zero
	Indices findInMatrix(MyData mat);
	MyData createSubMatrixVector(MyData mat, Indices indices);
	//Indexes findIndexesInMatrix(MyData mat);
	//MyData createSubMatrixVector(MyData mat, Indexes indexes);
	MyData& findIndexesInMatrix(MyData& mat);
//	MyData& createSubMatrixVectorSmallerOrEqToScalarVal(MyData& mat, const MyData& indexes,double scalar);
	MyData& createSubMatrixVector(MyData& mat, const MyData& indexes);
	MyData createSubMatrixVector(MyData mat, int startOfBuffer, int endOfBuffer);

	MyData& getMatrix(MyData& mat,MyData& rowsIndexes,int colStartOfBuffer,int colEndOfBuffer);
	MyData& getColumns(MyData& mat,int colStartOfBuffer,int colEndOfBuffer);
	MyData& createNewMatrixVectorAccordingToIndexes(MyData& mat, MyData& indexes);

	MyData& sortRows(MyData& mat,int columnNumber);
	MyData& sortRowsDecreasing(MyData& mat,int columnNumber);
	MyData& sortColsDecreasing(MyData& mat,int rowNumber);

	MyData& create3ElementsRowVector(double a, double b, double c);

	void copyColToMatrixColInIndex(MyData mat,MyData col , int index);

	//void setScalarValueInIndexes(MyData mat, Indexes indexes, double value);
	void setScalarValueInIndexes(MyData& mat, MyData& indexes, double value);

	double findMaxInMatrix(MyData& mat);

	MyData& roundMatrixValues(MyData& mat);

	MyData& pointMatrixMul(MyData& mat1,MyData& mat2);

	MyData& findSmallerThenScalar(MyData& mat, double scalar);
	MyData& findSmallerOrEqualThenScalar(MyData& mat, double scalar);
	MyData& findBiggerThenScalar(MyData& mat, double scalar);
	
	MyData& findEqualsToScalarIndexes(MyData mat, double scalar);
	MyData& findSmallerOrEqualsToScalarIndexes(MyData& mat, double scalar);

	MyData& sumMatrix(MyData& mat);
	MyData& meanMatrix(MyData& mat);

	double matrixNorm(MyData& F);

	double matrixStd(MyData& A);

	// Sort in ascending order
	// every column will be sorted in ascending order
	MyData& matrixSort(MyData mat);

	MyData& createMat(char const * fileName);
	void printMatToFile(MyData& mat, char const *fileName);
	void printMatToFileStandard(MyData& mat, char const *fileName);

	static double** allocateMemory(int numOfRows, int numOfCols);

	void printMatrix(const MyData& mat);

	MyData& copyMatrix(const MyData& matFrom);

	MyData& padFirstRowAndCol(MyData& mat);
	MyData removePadFirstRowAndCol(MyData mat);
	MyData& removePadFirstRowAndLastCol(MyData& mat);
	MyData removeCol(MyData mat , int colNumber);

	void mulFWith3elements2Results(double* result , MyData& F , double e1 , double e2 , double e3 , bool transposeFflag);
public:
	MyMath(void);
public:
	~MyMath(void);
};
